<?php
$globSiteName = '';
$globDescription = '';
//folgender detailblog vorab mit "nicht definiert" füllen
/*begin config*/
$myConfig = [
    'user' => '$2y$10$Upp0gB4scAxF44qSNidIBuOgDDDdWvkvAkRNuI4HdWCxDcJuDSNxu',
    'pass' => '$2y$10$3ZBe4bEc22D3ZkQ5GrEAxuJACA7YCZ9nl0EEcXUBbYOwOVlGM2X7G',
    'database' => 'fhwcms.sqlite',
    'startsite' => 'startseite',
    'errorsite' => 'fehlerseite',
    'detailblog' => 'blog',
    'getAdmin' => 'verwaltung',
    'version' => '0.202',
    'webserver' => 'https://w-web.de/muscms/',
    'updateUrl' => 'https://w-web.de/muscms/update/index.txt'
];
/*end config*/
session_start();

error_reporting(E_ERROR | E_PARSE);
//ini_set('display_errors','Off');
if (!isset($_SESSION['aktDir'])){
  $_SESSION['aktDir'] = '//';
}

function JsonOut($myMessage){
    header('Content-Type: application/json');
    echo json_encode($myMessage);
    exit;
}
function ErrorOut($errorMessage){
    JsonOut(['status' => 'ERROR','message' => $errorMessage]); 
}
function fieldTest($db, $table, $fields=null){
  $query = 'SELECT name FROM sqlite_master WHERE type="table" ORDER BY name;';
  $ret=execQuery($db, $query);
  $dbtables = [];
  foreach($ret['rows'] as $value){
      array_push($dbtables, $value->name);
  }
  if (in_array($table, $dbtables)){
    if ($fields==null) return true;
    $query = "PRAGMA table_info({$table})";
    $ret=execQuery($db, $query);
    $tablefields=[];
    foreach($ret['rows'] as $value){
      array_push($tablefields, $value->name);
    } 
    $fieldtest=true;
    foreach ($fields as $key => $value) {
      if (!in_array($key, $tablefields))
        $fieldtest=false;
    }
    if ($fieldtest) return true;
    else return false;
  } 
  else return false;
}
function execQuery($db, $query, $prep=null){
    try{
      $myQuery = $db->prepare($query);  
    }
    catch (PDOException $e){
        $isOK=false;
        //print_r( $e->getMessage() );
        $ret = [
          'status'  => 'ERROR',
          'affected' => null,
          'message' => $e->getMessage()
        ];
        return $ret;
    }
    if ($myQuery){
        try{
          $isOK=$myQuery->execute($prep);
        }
        catch (PDOException $e){
          //$isOK=false;
          //print_r( $e->getMessage() );
          $ret = [
            'status'  => 'ERROR',
            'affected' => null,
            'message' => $e->getMessage()
          ];
          return $ret;
        }
        if ($isOK){
            $myResult = $myQuery -> fetchAll(PDO::FETCH_OBJ);
            if(!empty($myResult) OR $myQuery->rowCount() != 0 ){
            $ret = [ 
                'status' => 'OK',
                'message' => 'Abfrage erfolgreich',
                'affected' => $myQuery->rowCount(),
                'rows' => $myResult,
                'lastins' => $db->lastInsertId()
                
            ];
            } else {
              $ret = [
                'status'  => 'ERROR',
                'affected' => $myQuery->rowCount(),
                'message' => 'keinen Datensatz gefunden!'
              ];
            }
        }
        if (!$isOK){
            $myQuery = false;
        }
    }
    if (!$myQuery){
        $ret = [
            'status'  => 'ERROR',
            'affected' => null,
            'message' => 'Datensatz besteht bereits!'
        ];
    }
    return $ret;
}
function checkFileExist($filename) {
  $filename = __DIR__.$_SESSION['aktDir'].$filename;
  if (!file_exists($filename)) {
    ErrorOut('Datei nicht vorhanden! (checkFileExist)'); 
  }
}
function checkFileNotExist ($filename) {
  $filename = __DIR__.$_SESSION['aktDir'].$filename;
  if (file_exists($filename)) {
    ErrorOut('Datei bereits vorhanden! (checkFileNotExist)'); 
  }
}
function checkFileInRoot ($filename) {
  $filename = __DIR__.$_SESSION['aktDir'].$filename;
  if(strpos(realpath(pathinfo($filename)['dirname']), __DIR__) !== 0){
    ErrorOut('Sie müssen im Document Root bleiben!'); 
  }
}
function checkFileExtension ($filename, $allowedExt){
  $filename = __DIR__.$_SESSION['aktDir'].$filename;
  $ext = pathinfo($filename, PATHINFO_EXTENSION);
  if (!in_array($ext, $allowedExt)){
    ErrorOut('Diese Datei kann nicht geändert werden!'); 
  }
}
function isRegularExpression($string) {
    return @preg_match($string, '') !== FALSE;
}
//*********************************
//-------Module -------------------
//*********************************

//allowed functions (moduls)
$allowedModFunctions = array ();
if (file_exists (__DIR__.'/'.'muscmsmod.php')){
    include __DIR__.'/'.'muscmsmod.php';
}

array_push($allowedModFunctions, 'test');

function test($parameter) {
  $db = $parameter[0] ?? null;
  $site = $parameter[1] ?? null;
  $test = $parameter[2] ?? '';
  
  $html='';
  
  /*
  if ($db){
    try{
      $myQuery=$db->prepare('select html from websites where title = :title');  
    }
    catch (PDOException $e){
      $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
      return $html;
    } 
    $prep = ['title' => $insert];
    $myQuery->execute($prep);
    $myResult = $myQuery -> fetchAll(PDO::FETCH_ASSOC);
    if($myResult && count($myResult)){
     
      foreach ($myResult as $row){
        $html .= $row['html'];
        }
    }
    return $html;
  }
  */
  return "<p>Modul: <b>test: {$test} </b></p>";
}

array_push($allowedModFunctions, 'news');
function news ($parameter) {
  //->Parameter 02 => erster Eintrag 
  //->Parameter 03 => Anzahl anzuzeigender Einträge
  //->Parameter 04 => DetailviewSite
  //->Parameter 05 => Template
  //->Parameter 06 => Footer Template
  //->Parameter 07 => readmoreText;
  
  $db = $parameter[0] ?? null;
  $site = $parameter[1] ?? null;
  $firstEntry = $parameter[2] ?? ''; 
  $numberOfEntries = $parameter[3] ?? 1;
  $detailView = $parameter[4] ?? '';
  $template = $parameter[5] ?? '';
  $footertemplate = $parameter[6] ?? '';
  $readMoreText = $parameter[7] ?? 'weiterlesen';
  
  $getNumberOfEntries = $_GET['numberofentries'] ?? null;
  if ($getNumberOfEntries){
    if(is_int($getNumberOfEntries*1)){
      $numberOfEntries = $getNumberOfEntries;
    }
  }
  
  $getFirstEntry = $_GET['news'] ?? null;
  if ($getFirstEntry){
    if (date('Y-m-d\TH:i',strtotime($getFirstEntry))==$getFirstEntry) {
      $firstEntry=$getFirstEntry;
    }
  }
  
  $html='';

  
  $defaultTemplate = '
      <!-- begin Blog Entry -->
      <article data-newsoverview>
        <header>
        <h3>{{header}}</h3>
        </header>
        {{headertext}}
       <footer>
        <p>Datum: <strong>{{date}}</strong></p>
        <p>Uhrzeit: <strong>{{time}}</strong></p>
        <p>Autor: <strong>{{author}}</strong></p>
        <p>Tags: <strong>{{tags}}</strong></p>
        <p>{{readmorelink}}</p>
        </footer>
      </article>
      <!-- end Blog Entry -->
  ';
  
  
  $defaultFooterTemplate = '
    <div data-newsfooter><p>{{newerEntries}}</p><p>{{olderEntries}}</p></div>
  ';
  /* Detailansicht */
  if ($numberOfEntries==1){
  $defaultTemplate = '
      <!-- begin Blog Entry -->
      <article data-newsdetail>
        <header>
        <h3>{{header}}</h3>
        </header>
        {{content}}
       <footer>
        <p>Datum: <strong>{{date}}</strong></p>
        <p>Uhrzeit: <strong>{{time}}</strong></p>
        <p>Autor: <strong>{{author}}</strong></p>
        <p>Tags: <strong>{{tags}}</strong></p>
        </footer>
      </article>
      <!-- end Blog Entry -->
  ';
  }
  
  
  $getTemplate = $_GET['template'] ?? null;
    if($getTemplate){
      $template = $getTemplate;
    }
  //checkIfTemplate exist
  if($template !=''){
    $query = 'select * from templates where title = :title';
    try{
        $myQuery=$db->prepare($query);  
      }
    catch (PDOException $e){
      $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
      return $html;
    }
    $prep = ['title' => $template];
    $myQuery->execute($prep);
    $myResult = $myQuery -> fetch(PDO::FETCH_ASSOC);
    if ($myResult){
      $defaultTemplate = $myResult['content'];
    };
  }
  
  
  $getFooterTemplate = $_GET['templatefooter'] ?? null;
    if($getFooterTemplate){
      $footertemplate = $getFooterTemplate;
    }

  //checkIfTemplate exist
  
  if($footertemplate !=''){
    $query = 'select * from templates where title = :title';
    try{
        $myQuery=$db->prepare($query);  
      }
    catch (PDOException $e){
      $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
      return $html;
    }
    $prep = ['title' => $footertemplate];
    $myQuery->execute($prep);
    $myResult = $myQuery -> fetch(PDO::FETCH_ASSOC);
    if ($myResult){
      $defaultFooterTemplate = $myResult['content'];
    };
  }
  
  if ($numberOfEntries>1){
    if($detailView==''){
      return '<p>modul: <strong>news </strong> --> keine Zielseite angegeben!</p>';
    }
  } else {
    $detailView=$site;
  }
  
  
  if ($db){
    if($firstEntry != ''){ 
      $query = "select * from news where date <= :first and visible = 'ja' order by date desc limit :limit";
      $prep = ['first' => $firstEntry, 'limit' => $numberOfEntries];
    } else {
      $query = "select * from news where visible = 'ja' order by date desc limit :limit";
      $prep = ['limit' => $numberOfEntries];
    }
    try{
      $myQuery=$db->prepare($query);  
    }
    catch (PDOException $e){
      $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
      return $html;
    }
    $myQuery->execute($prep);
    $myResult = $myQuery -> fetchAll(PDO::FETCH_ASSOC);
    
    if (count($myResult)==0){
      return '<h1>keine News vorhanden</h1>';
    }
    
    $latestEntry = '';
    $oldestEntry = '';
    
    if($myResult && count($myResult)){
      foreach ( $myResult as $row ){
        if ($latestEntry == ''){
          $latestEntry = $row['date'];
        }
        $oldestEntry = $row['date'];
        $date = date('d.m.Y',strtotime($row['date']));
        $time = date('G:i',strtotime($row['date']));
        $header = $row['heading'];
        $headertext = $row['headingtexthtml'];
        $content = $row['contenthtml'];
        $themeUrl=str_replace(' ', '%20', $row['heading']);
        $readmorelink = '<a href="index.php?site='.
          $detailView.'&news='.$row['date'].'&theme='.
          $themeUrl.'">'.$readMoreText.'</a>';
        
        $author = $row['author'];
        $tags = $row['tags'];
        $description = $row['description'];
        
        
        $myReplace = array(
          '{{header}}' => $header,
          '{{headertext}}' => $headertext,
          '{{content}}' => $content,
          '{{date}}' => $date,
          '{{time}}' => $time,
          '{{readmore}}' => $readmore,
          '{{readmorelink}}' => $readmorelink,
          '{{description}}' => $description,
          '{{tags}}' => $tags,
          '{{author}}' => $author
        );
        
        
        
        $html .= strtr($defaultTemplate, $myReplace);
        
      }
      if ($numberOfEntries==1){
        $GLOBALS['globSiteName']=$row['heading'];
        $GLOBALS['globDescription']=$row['description'];
      }
      
      //older an newer Entries
      //newest
      $query = "select date, heading from news where date > :date  order by date limit :limit";
      try{
        $myQuery=$db->prepare($query);
          }
      catch (PDOException $e){
        $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
        return $html;
      } 
      $prep = ['date' => $latestEntry, 'limit' => $numberOfEntries];
      $myQuery->execute($prep);
      $myResult = $myQuery -> fetchAll(PDO::FETCH_ASSOC);
      if($myResult && count($myResult)){
        foreach ( $myResult as $row )
        {
          $themeURL = str_replace(' ', '%20', $row['heading']);
          $latestEntry = "nächster Beitrag: <a href = 'index.php?site={$site}&news={$row['date']}&theme={$themeURL}&numberofentries={$numberOfEntries}&template={$template}&templatefooter={$footertemplate}'>{$row['heading']}</a>";
        }        
      } else {
        $latestEntry = 'keine neueren Einträge vorhanden';
      }
      
      // check ob ältere Beiträge
      $query = "select date, heading from news where date < :date  order by date desc limit 1";
      try{
        $myQuery=$db->prepare($query);
      }
      catch (PDOException $e){
        $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
        return $html;
      }
      $prep = ['date' => $oldestEntry];
      $myQuery->execute($prep);
      $myResult = $myQuery -> fetchAll(PDO::FETCH_ASSOC);
      if($myResult && count($myResult)){
        foreach ( $myResult as $row )
        {
          $themeURL = str_replace(' ', '%20', $row['heading']);
          $oldestEntry = "vorheriger Beitrag: <a href = 'index.php?site={$site}&news={$row['date']}&theme={$themeURL}&numberofentries={$numberOfEntries}&template={$template}&templatefooter={$footertemplate}'>{$row['heading']}</a>";
        }
      }  else {
        $oldestEntry = 'keine älteren Beiträge vorhanden';
      }
      
      $myReplace = array(
          '{{newerEntries}}' => $latestEntry,
          '{{olderEntries}}' => $oldestEntry
        );
      $html .= strtr($defaultFooterTemplate, $myReplace);
      return $html;
    }  
  }
  return '<p>Modul: <b>news</b></p>';
}

array_push($allowedModFunctions, 'menu');
function menu ( $parameter ) {
  $db = $parameter[0] ?? null;
  $site = $parameter[1] ?? null;
  $maxDepth = $parameter[2] ?? 9999;
  $menuType = $parameter[3] ?? 'ul';
  if ($menuType == 'ul'){
    $ulOpen = '<ul>'.PHP_EOL;
    $ulClose = '</ul>'.PHP_EOL;
    $liOpen = '<li>';
    $liClose = '</li>'.PHP_EOL;
  }
  if ($menuType == 'p'){
    $ulOpen = '';
    $ulClose = '';
    $liOpen = '<p>';
    $liClose = '';
  }
  
  
  $html = '';
  if ($db){
    try{
      $myQuery=$db->prepare('select title, menutitle from websites where visible == "ja" order by menuorder');  
    }
    catch (PDOException $e){
      $html = "<p>Das ist daneben gegangen <b>".$e->getMessage().'</b></p>';
      return $html;
    }
    $myQuery->execute();
    $myResult = $myQuery -> fetchAll(PDO::FETCH_ASSOC);
    if($myResult && count($myResult)){
      $html = $ulOpen;
      $depth = 0;
      foreach ( $myResult as $row){
        $value = $row['title'];
        $menuTitle = '<a href="index.php?site='.$value.'">'.$row['menutitle'].'</a>';
        $tDepth = substr_count($value,'-');
        
        if ($tDepth==$depth){
          $html.= $liOpen.$menuTitle.PHP_EOL;
        }
        
        if ($tDepth>$depth){
          if ($tDepth > $maxDepth){
            $tDepth--;
            continue;
          }
          $depth=$tDepth;
          $html.=$ulOpen.$liOpen.$menuTitle.PHP_EOL;
        }
        
        if ($tDepth<$depth){
          for ( $i = $tDepth ;$i < $depth; $i++){
            $html.=$ulClose;
          }
          $depth=$tDepth;
          $html.=$liOpen.$menuTitle.PHP_EOL;
        }
      }
      for ( $i = 0 ;$i < $depth; $i++){
        $html.=$ulClose;
      }
      $html.=$ulClose;
    }
    return $html;  
  }
  return '<p>Modul: <b>menu</b></p>';
}

//*********************************
//-------Ende Module --------------
//*********************************

$myConfig['allowedModFunctions'] = $allowedModFunctions;
class musadmin{
  var $config;
  var $post;
  var $allowedActions=['checklogin', 'login'];
  var $adminActions = [
    'changeDir',
    'changeSettings',
    'checklogin',
    'createDir',
    'createFile',
    'createHtaccess',
    'deleteFile',
    'deleteTableRow',
    'detail',
    'getAllDirectories',
    'getBricksForEditor',
    'getDabas',
    'getImages',
    'getInfo',
    'getLinks',
    'getSitesForEditor',
    'getSQLFiles',
    'getTables',
    'getTemplates',
    'getTextBlocks',
    'login',
    'logout',
    'overview',
    'readDirectory',
    'renameFile',
    'sqlDump',
    'sqlImport',
    'sqlEdit',
    'save',
    'saveStylesheet',
    'upload',
    'update',
    'vacuum'
  ];
  var $querys = [
    'getCount' => 'SELECT
        (SELECT COUNT(DISTINCT rowid) FROM websites) AS websites,
        (SELECT COUNT(DISTINCT rowid) FROM textblocks) AS textblocks,
        (SELECT COUNT(DISTINCT rowid) FROM news) AS news,
        (SELECT COUNT(DISTINCT rowid) FROM templates) AS templates',
    'overviewwebsites' => 'select rowid, title, menuorder, metadescription from websites order by menuorder',
    'overviewnews' => 'select rowid, date, description from news order by date desc',
    'overviewtextblocks' => 'select rowid, title, description from textblocks order by title',
    'overviewtemplates' => 'select rowid, title, description from templates order by title',
    'getTemplates' => 'select title from templates where show="ja" order by title'
  ];
  function __construct ($config, $post=null){
    $this->config = $config;
    $this->post = $post;
    $databaseFile=__DIR__.'/'.$this->config['database'];
    if (file_exists ($databaseFile)){
      try {$db = new PDO('sqlite:'.$databaseFile);}      
      catch(PDOException $e){
        echo $e->getMessage();
      }
      $this->config['db'] = $db;
    } 
    else 
    {
      $this->createNewDatabase ($databaseFile);
    }
  }
  function changeDir(){
    $newDir = $_POST['directory'] ?? '';
    checkFileExist($newDir);
    checkFileInRoot($newDir);
    $_SESSION['aktDir']='/'.str_replace(__DIR__, '', realpath(__DIR__.$_SESSION['aktDir'].$newDir)).'/';
    chdir(__DIR__.$_SESSION['aktDir']);
    JsonOut([
      'status' => 'OK',
      'message' => 'changeDir',
      'post' => $_POST,
      'newDir' => $newDir,
      'aktDir' => $_SESSION['aktDir']
    ]);  
  }
  function changePass(){
    $user = $_POST['username'] ?? "";
    $pass = $_POST['password'] ?? "";
    $user = password_verify($user,$this->config['user']);
    $pass = password_verify($pass,$this->config['pass']);
    if($user && $pass){
      $newUser = $_POST['newusername'] ?? "";
      $newPass = $_POST['newpassword'] ?? "";
      if ($newUser=='')ErrorOut('keine leeren Werte');
      if ($newPass=='')ErrorOut('keine leeren Werte');
      $newUserHash = password_hash($newUser, PASSWORD_DEFAULT);                    
      $newPassHash = password_hash($newPass, PASSWORD_DEFAULT);
      $myFile = file_get_contents(__FILE__);
      $parameter = 'user';
      $muster = "/'{$parameter}' => '.*'/";
      preg_match ($muster, $myFile, $match);
      $myFile = str_replace($match[0]??'',"'{$parameter}' => '".$newUserHash."'", $myFile);
      $parameter = 'pass';
      $muster = "/'{$parameter}' => '.*'/";
      preg_match ($muster, $myFile, $match);
      $myFile = str_replace($match[0]??'',"'{$parameter}' => '".$newPassHash."'", $myFile);
      $isWrite= file_put_contents(__FILE__, $myFile);
      unset($_SESSION['login']);
      unset($_SESSION['previewmode']);  
      JsonOut(
        ['status' => 'OK',
        'message' => 'Passwort geändert!'
        ]);    
    } else {
      ErrorOut('User oder Passwort verkehrt'); 
    }
  }
  function changeSettings () {
    $whatToDo = $_POST['setting'] ?? '';
    if ($whatToDo == '') ErrorOut('keine leeren Werte');
    
    if ($whatToDo == 'changePass'){
      $this->changePass();
    }
    $newValue = $_POST['newVal'] ?? '';
    if ($newValue=='') ErrorOut('keine leeren Werte');
    switch($whatToDo){
      case 'changeStartPage':
        $this->replaceParameter('startsite', $newValue);
        break;
      case 'changeErrorPage':
        $this->replaceParameter('errorsite', $newValue);
        break;
      /*  
      case 'changePass':
        $this->changePass();
        break;
      */  
      case 'changeAdmin':
        $this->replaceParameter('getAdmin', $newValue);
        break;
      case 'changeBlogPage':
        $this->replaceParameter('detailblog', $newValue);
        break;
      
      case 'changeDatabase':
        checkFileExist($newValue);
        checkFileInRoot($newValue);
        $this->replaceParameter('database', $newValue);
        break;
        
      case 'newDaba':
        if(!preg_match('/^[a-z]+$/i',$newValue))
          ErrorOut('der Name enthält unerlaubte Zeichen');
        
        $newValue.='.sqlite';
        checkFileNotExist($newValue);
        checkFileInRoot($newValue);
        $databaseFile=__DIR__.'/'.$newValue;
        $this->createNewDatabase($databaseFile);
        $this->replaceParameter('database', $newValue);
        break;
        
      case 'stemplate':
        $template = $newValue;
        $query = "update websites set template = :template";
        $ret = execQuery($this->config['db'], $query,[$template]);
        JsonOut($ret);
        break;
        

    }
    JsonOut(
      ['status' => 'OK',
        'message' => 'Einstellung geändert!',
        'post' => $_POST]);     
    }
  function checkLogin(){
    $isLogin = $_SESSION['login'] ?? false;
    JsonOut([
          'status' => 'OK',
          'login' => $isLogin
    ]);
  }
  function createDir(){
    $dirName = $_POST['dirName'] ?? '';
    checkFileNotExist($dirName);  
    checkFileInRoot($dirName);  
    mkdir(__DIR__.$_SESSION['aktDir'].$dirName);
    JsonOut([
      'status' => 'OK',
      'message' => 'Verzeichnis erstellt!'
    ]);
  }
  function createHtaccess () {
    $filename = __DIR__.'/.htaccess';
    if (file_exists($filename)) {
      ErrorOut('htaccess bereits vorhanden!'); 
    }
    $myfile = fopen($filename, "w") or ErrorOut("Unable to open file!");
    $txt = "# erstellt von muscms \n";
    fwrite($myfile, $txt);
    fclose($myfile);
    JsonOut([
      'status' => 'OK',
      'message' => '.htaccess erstellt!'
    ]);
  }
  function createFile () {
    if($_SESSION['aktDir']=='//'){
      ErrorOut('nicht im Root Verzeichnis!!');
    }
    $regex = '/^[a-z]+.(js$|css$)/';
    $filename = $_POST['filename'] ?? '';
    if(!preg_match($regex, $filename, $matches, PREG_UNMATCHED_AS_NULL )){
      ErrorOut('unerlaubter Dateiname!');
    }
    $filename = __DIR__.$_SESSION['aktDir'].$filename;
    if (file_exists($filename)) {
      ErrorOut('Datei bereits vorhanden!'); 
    }
    $myfile = fopen($filename, "w") or ErrorOut("Unable to open file!");
    fclose($myfile);
    JsonOut([
      'status' => 'OK',
      'message' => 'Datei erstellt!',
    ]);
  }
  function createNewDatabase ($databaseFile){
$query = <<< EndMyCreateQuery
CREATE TABLE [news](
[date] TEXT(16) PRIMARY KEY ASC NOT NULL UNIQUE, 
[author] TEXT NOT NULL, 
[heading] TEXT NOT NULL, 
[headingtext] TEXT NOT NULL, 
[content] TEXT NOT NULL, 
[visible] TEXT NOT NULL, 
[tags] TEXT NOT NULL,
[description] TEXT NOT NULL,
[headingtexthtml] TEXT NOT NULL,
[contenthtml] TEXT NOT NULL);
CREATE TABLE [textblocks](
[title] TEXT(100) PRIMARY KEY ASC NOT NULL UNIQUE, 
[description] TEXT(255) NOT NULL, 
[content] TEXT NOT NULL,
[show] TEXT);
CREATE TABLE [websites](
[title] TEXT PRIMARY KEY ASC NOT NULL UNIQUE, 
[menutitle] TEXT NOT NULL, 
[menuorder] TEXT, 
[content] TEXT NOT NULL, 
[metadescription] TEXT NOT NULL, 
[metatitle] TEXT NOT NULL, 
[metakeywords] TEXT NOT NULL, 
[template] TEXT NOT NULL, 
[visible] TEXT NOT NULL,
[html] TEXT NOT NULL);
CREATE TABLE [templates](
[title] TEXT(100) NOT NULL UNIQUE, 
[description] TEXT(255) NOT NULL, 
[content] TEXT NOT NULL,
[show] TEXT NOT NULL);
insert into websites
(title, menutitle, menuorder, content, metadescription, metatitle, metakeywords, template, visible, html)
values
("startseite", "home", "1000", "#Startseite", "Beschreibung", "Titel", "Schlüsselwörter", "default", "ja", "<h1>Startseite</h1>");
insert into websites
(title, menutitle, menuorder, content, metadescription, metatitle, metakeywords, template, visible, html)
values
("fehlerseite", "error", "9000", "#Fehlerseite", "Beschreibung", "Titel", "Schlüsselwörter", "default", "nein", "<h1>Fehlerseite</h1>");
INSERT INTO templates
(title, description, content, show)
values
("default",
"voreingestelltes Template",
'<!DOCTYPE html>
<html lang=de>
<head>
  <meta charset=UTF-8>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name=description content="{{description}}">
  <meta name=keywords content="{{keywords}}">
  <title>{{metatitle}}</title>
</head>
<body class=container>
<mod>menu(1)</mod>
<hr>
  {{content}}
</body>
</html>
',
'ja'
);
EndMyCreateQuery; 
$db = new PDO('sqlite:'.$databaseFile);
$this->config['db'] = $db;
$db->exec($query);  
}
  function deleteFile(){
    $filename = $_POST['filename'] ?? '';
    
    if ($this->config['database']==$filename){
      ErrorOut ( 'aktive Datenbank kann nicht gelöscht werden!');
    }
    
    
    checkFileExist ($filename);
    checkFileinRoot ($filename);
    
    $filename = __DIR__.$_SESSION['aktDir'].$filename;
    
    if (is_dir($filename)){
      if(count(glob("$filename/*")) === 0){
        rmdir($filename);
        JsonOut([
          'status' => 'OK',
          'message' => 'Verzeichnis gelöscht!'
        ]);
      } else {
        ErrorOut('Verzeichnis ist nicht leer');
      }
    }
    
    ob_start();
    $delSuccess = unlink($filename);
    $message = ob_get_Contents();
    ob_end_clean();
    if ( $delSuccess) 
      JsonOut([
        'status' => 'OK',
        'message' => 'Datei gelöscht!'
      ]);
    ErrorOut(trim(preg_replace('/\s\s+/', ' ', strip_tags($message))));
  }

  function deleteTableRow (){
    $table = $_POST['table'] ?? null;
    unset($_POST['table']);
    unset($_POST['action']);
    if(fieldTest($this->config['db'], $table)){
      $query = "delete from {$table} where rowid = :rowid";
      $ret = execQuery($this->config['db'], $query, $_POST);
      JsonOut($ret);
    }
    else {
      ErrorOut('Datensatz konnte nicht gelöscht werden!');
    }
  }
  function detail() {
    $table = $_POST['table'] ?? null;
    $rowid = $_POST['rowid'] ?? null;
    $prep = [
      'rowid' => $rowid
    ];
    if(fieldTest($this->config['db'], $table)){
      $query = "select rowid,* from {$table} where rowid = :rowid";
      $ret = execQuery($this->config['db'], $query, $prep);
      $ret['table']=$table;
      JsonOut($ret);
    }
    else {
      ErrorOut('undefinierbarer Fehler getdetail!');
    }
  }
  function exportSQLite($expdb, $dabaFile, $tables){ 
    $fileName = str_replace('.sqlite', '.sql', $dabaFile);
    checkFileNotExist($fileName);
    checkFileInRoot($fileName);
    $fp = fopen($fileName, 'w');
    foreach ($tables as $table){
      // Code for Create Database
      $myQuery = $expdb->prepare('select sql from sqlite_master where name = :tablename');
      $prep = ['tablename' => $table];
      $myQuery->execute($prep);
      $myTableDefs = $myQuery -> fetch(PDO::FETCH_OBJ);
      $defOut = str_replace('CREATE TABLE', 'CREATE TABLE IF NOT EXISTS', $myTableDefs->sql);
      fwrite($fp,$defOut.';'.PHP_EOL);
      // Code for Insert or Update
      $myQuery = $expdb->prepare("pragma table_info({$table})");
      $myQuery->execute();
      $myColumnNames = $myQuery -> fetchAll(PDO::FETCH_OBJ);
      $insert = "INSERT OR REPLACE INTO {$table} (";
      foreach($myColumnNames as $column){
        $insert.= $column->name.',';      
      }
      $insert = substr($insert, 0, -1);
      $insert.= ") VALUES".PHP_EOL;
      $myQuery = $expdb->prepare("select count(*) as count from {$table}");
      $myQuery->execute();
      $myResult = $myQuery->fetch(PDO::FETCH_ASSOC);
      $rowCount = $myResult['count'];
      if ($rowCount!=0){
        fwrite($fp,$insert);
      }
      //nun die Daten
      $sepRow = 1;
      $myQuery = $expdb->prepare("select * from {$table}");
      $myQuery->execute();
      while($fetch = $myQuery->fetch(PDO::FETCH_ASSOC)){
        $dasa = "(";
        $sepCol=1;
        foreach($fetch as $col){
          $sepString = ($sepCol < sizeof($fetch)) ? ',' :'';
          $dasa.= $expdb->quote($col ?? '').$sepString.PHP_EOL; //geändert ?? am 21.08.2022
          $sepCol++;
        }
        $sepRowString = ($sepRow < $rowCount) ? ',' :';';
        $sepRow++;
        $dasa .= ")".$sepRowString.PHP_EOL;
        fwrite($fp, $dasa);
      }
    }
  fclose($fp);
}
  function getAllDirectories () {
    function getSubDirectories($dir)
    {
      $subDir = array();
      $directories = array_filter(glob($dir), 'is_dir');
      $subDir = array_merge($subDir, $directories);
      foreach ($directories as $directory) $subDir = array_merge($subDir, getSubDirectories($directory.'/*'));
      return $subDir;
    }
    $allDirs = str_replace(__DIR__, '', getSubDirectories(__DIR__));
    $allDirs[0]='/';
    JsonOut([
    'status' => 'OK',
    'message' => 'Verzeichnis gelesen',
    'dirs' => $allDirs,
    'aktDir' => __DIR__
    ]);
  }
  function getBricksForEditor(){
    $query = $this->querys['getBricksForEditor'];
    JsonOut(execQuery($this->config['db'], $query));
  }
  function getContent($db, $element, $errorpage){
    $myQuery = $db->prepare(
    'select title, metakeywords, metadescription, template, metatitle, content, html from websites where title = :title');
    $myQuery->bindParam(":title", $element, PDO::PARAM_STR);
    $myQuery->execute();
    $myResult = $myQuery -> fetch(PDO::FETCH_ASSOC);
    if($myResult && count($myResult))
    {
    return($myResult);
    }
    else
    {    
      $myQuery->bindParam(":title", $errorpage, PDO::PARAM_STR);
      $myQuery->execute();
      $myResult = $myQuery -> fetch(PDO::FETCH_ASSOC);
      if($myResult && count($myResult)){
        return($myResult);
      }
      else{
        header('location: index.php?'.$this->config["getAdmin"]);       
      }
    }
}
  function getDabas () {
    $files = array_map('basename', glob(__DIR__.'//'.'*.sqlite', GLOB_BRACE));
    JsonOut([
      'status' => 'OK',
      'message' => 'Abfrage erfolgreich',
      'rows' => $files
    ]);
  }
  function getImages (){
    $Directory = new RecursiveDirectoryIterator(__DIR__.'/');
    $Iterator = new RecursiveIteratorIterator($Directory);
    $Regex = new RegexIterator($Iterator, '/^.+(.jpeg|.png|.gif|.jpg|.svg|.svgz|.apng|.webp|.avif)$/i', RecursiveRegexIterator::GET_MATCH);
    $images = array();
      foreach($Regex as $name => $Regex){
       $name = str_replace(__DIR__, '.', $name);
       $name = str_replace('\\','/',$name);
       $name = str_replace('./','/',$name);
       array_push ($images, $name);
      }
    JsonOut(['status' => 'OK',
             'message' => 'Abfrage erfolgreich',
             'rows' => $images]);    
  }
  function getInfo(){
    $data = (execQuery($this->config['db'], $this->querys['getCount']));
    $data['websites']="Anzahl: <b>{$data['rows'][0]->websites}</b>";
    $data['news']="Anzahl: <b>{$data['rows'][0]->news}</b>";
    $data['textblocks']="Anzahl: <b>{$data['rows'][0]->textblocks}</b>";
    $data['templates']="Anzahl: <b>{$data['rows'][0]->templates}</b>";
    unset($data['rows']);
    $data['version'] = "aktuell: <b>{$this->config['version']}</b>";
    $data['startsite'] = "<b>{$this->config['startsite']}</b>";
    $data['errorsite'] =  "<b>{$this->config['errorsite']}</b>";
    $data['detailblog'] =  "<b>{$this->config['detailblog']}</b>";
    $data['getadmin'] =  "index.php?<b>{$this->config['getAdmin']}</b>";
    $data['database'] =  "aktiv: <b>{$this->config['database']}</b>";   
    $data['logout'] =  'Status: <b>eingeloggt</b>';   
    $data['copyright'] =  '<b>FHW22</b>';   
    $data['license'] =  '<b>noch nicht festgelegt</b>';   
    $Directory = new RecursiveDirectoryIterator(__DIR__.'/',RecursiveDirectoryIterator::SKIP_DOTS);
    $Iterator = new RecursiveIteratorIterator($Directory);
    $countFiles = iterator_count($Iterator);
    $data['files'] =  "Anzahl: <b>{$countFiles}</b>"; 
    JsonOut($data); 
  }
  function getLinks () {
    $query = "select title from websites  order by menuorder";
    JsonOut(execQuery($this->config['db'], $query));
  }
  function getSitesForEditor(){
    $query = $this->querys['getSitesForEditor'];
    JsonOut(execQuery($this->config['db'], $query));
  }  
  function getSQLFiles(){
    $files = array_map('basename', glob(__DIR__.$_SESSION['aktDir'].'*.sql', GLOB_BRACE));
    if (count($files) > 0)
      JsonOut([
        'status' => 'OK',
        'message' => 'Abfrage erfolgreich',
        'rows' => $files
      ]);
    ErrorOut('keine SQL Dateien vorhanden!');
  }
  function getTemplates () {
    $data = (execQuery($this->config['db'], $this->querys['getTemplates'])); 
    JsonOut($data);
  }
  function getTextBlocks () {
    $query = 'select title from textblocks where show = "ja"';
    JsonOut(execQuery($this->config['db'], $query));
  }
  function getTables () {
    $database = $_POST['database'] ?? '';
    if ($database !== ''){
      checkFileExist($database);
      checkFileInRoot($database);
      $dbfile = __DIR__.'/'.$database;
      try {$db = new PDO('sqlite:'.$dbfile);}      
      catch(PDOException $e){
        echo $e->getMessage();
      }
      $query = 'SELECT name FROM sqlite_master WHERE type="table" ORDER BY name;';
      JsonOut(execQuery($db, $query));
    }
  }
  function getTemplateToRender($template){
    $myQuery = $this->config['db']->prepare('select content from templates where title = :title');
    $myQuery->bindParam(":title", $template, PDO::PARAM_STR);
    $myQuery->execute();
    $myResult = $myQuery -> fetch(PDO::FETCH_ASSOC);
    if($myResult && count($myResult))
    {
     return $myResult['content'];
    } else {
      return '<p>Das Template <b>'.
        $template.'</b> ist nicht vorhanden!</p><a href="'.'index.php?'
        .$this->config["getAdmin"].'">zur Verwaltung</a>';
    }
  }
  function handleAction () {
    $isLogin = $_SESSION['login'] ?? false;
    $action = $this->post['action'] ?? "";    
    
  
    
    // wenn nicht eingeloggt dürfen nur die actions 
    // login und checklogin ausgeführt werden
    if (!$isLogin){
      if (in_array($action, $this->allowedActions)){
        $this->$action();
      } 
    }
    // wenn eingeloggt nur die erlaubten adminactions
    // ausführen
    if  (isset($_SESSION['login'])){
      if (in_array($action, $this->adminActions)){
        $_SESSION['previewmode']=true;
        $this->$action();
      }
    }
    
    // hier das Ajax Interface Module evtl. später einbauen, wenn es denn benutzt wird...

    // wenn eingeloggt und previewmode gesetzt ist
    if  (isset($_SESSION['previewmode'])){
      $site = $_POST["site"] ?? $_GET["site"] ?? $this->config['startsite'];
      $html=$this->renderPage($site);
      header('Content-Type: text/html; charset=utf-8');
      echo $html;
    }
    
    //wenn nicht eingeloggt normaler Seitenaufruf
    if  (!isset($_SESSION['login'])){
      //session_destroy();
      $site = $_POST["site"] ?? $_GET["site"] ?? $this->config['startsite'];
      $html=$this->renderPage($site);
      header('Content-Type: text/html; charset=utf-8');
      echo $html;
    }  
    
   
  }
  function login () {
    $user = $this->post['user'] ?? "";
    $pass = $this->post['pass'] ?? "";
    $user = password_verify($user,$this->config['user']);
    $pass = password_verify($pass,$this->config['pass']);
    if($user && $pass){
      $_SESSION['login']=true;   
      if (!isset($_SESSION['aktdir'])) {
        $_SESSION['aktdir']='/';
      }
      JsonOut(['status' => 'OK','message' => 'Login erfolgreich']);
    } else {
      ErrorOut('Loginfehler');
    }
  }
  function logout () {
    unset($_SESSION['login']);
    unset($_SESSION['previewmode']);
    JsonOut(['status' => 'OK','message' => 'Logout erfolgreich']);
  }
  function lookForModules($db,$html,$allowedModFunctions, $site){
    preg_match_all('/<mod>(.*)<\/mod>/',$html,$matches);
      foreach ($matches[1] as $myFunction){
        $mymodComplete = explode ( '(', $myFunction);
        $myFunctionName = trim ($mymodComplete[0]);
        if (isset($mymodComplete[1])){
            $parameter = trim($mymodComplete[1],') ');
            $parameter = str_getcsv($parameter);
            $parameter = array_map(function($el){
                return trim($el ?? '', " \'");
            }, $parameter);
        } else {
          $parameter = [];
        }
       array_unshift($parameter,$site);  
       array_unshift($parameter,$db);
        if (in_array($myFunctionName, $allowedModFunctions)) {

          
          
          $html = str_replace("<mod>" . $myFunction . "</mod>", $myFunctionName($parameter), $html);
        } else {
          $html = str_replace("<mod>" . $myFunction . "</mod>",
          '<p style="color:red;">Das Modul: <strong>'.$myFunctionName.'</strong> ist nicht vorhanden!</p>', $html);
        } 
      }
    return $html;
  }
  function lookForTextBlocks($db,$html){
    function getBlock($db, $element){
      $myQuery = $db->prepare('select content from textblocks where title = :title');
      $myQuery->bindParam(":title", $element, PDO::PARAM_STR);
      $myQuery->execute();
      $myResult = $myQuery -> fetch(PDO::FETCH_ASSOC);
      if($myResult && count($myResult))
      {
       return $myResult['content'];
      }
      else
      {
          return '<p style="color:red;">der Baustein <strong>'.$element.'</strong> ist nicht vorhanden!</p>';
      }
    }
    $maxBlocks = 100;
    $aktBlock = 0;
    //while (strpos($html, '{b{')) {
    while (strpos($html, '<ftb>')) {
      if($aktBlock == $maxBlocks){
        return $html;
      }
      $aktBlock++;
      
      preg_match_all("/<ftb>(.*?)\<\/ftb>/", $html, $matches);
      foreach ($matches[1] as $befehl) {
          $html = str_replace('<ftb>'. $befehl .'</ftb>', getBlock($this->config['db'], $befehl), $html);
      }
    }
    return $html;
  }
  function overview(){
    $table = $_POST['action'].$_POST['table']??'';
    if (isset($this->querys[$table])){
      $data = (execQuery($this->config['db'], $this->querys[$table])); 
      JsonOut($data);
    }
    ErrorOut('Falsche Tabelle');
  }
  function readDirectory () {
    function myFileSize($b){
      $f = floor((strlen($b) - 1) / 3);
      if ($f > 0) $sz = 'KMGT';
      return sprintf("%.0f", $b / pow(1024, $f)) .' '. @$sz[$f - 1] . 'Byte';
    }  
    $myExtension = [
    'sqlite' => 'Datenbank', 
    'php' => 'PHP-Datei',
    'js' => 'Javascript',
    'css' => 'Stylesheet',
    'html' => 'HTML',
    'htm' => 'HTML',
    'sql' => 'SQL Dump',
    'ico' => 'Icon',
    'pdf' => 'PDF',
    'txt' => 'Text', 
    'mp4' => 'Video', 
    'jpg' => 'Bild',
    'jpeg' => 'Bild', 
    'png' => 'Bild', 
    'svg' => 'Bild',
    'svgz' => 'Bild',
    'gif' => 'Bild',
    'apng' => 'Bild',
    'webp' => 'Bild',
    'avif' => 'Bild',
    'eot' => 'Font',
    'ttf' => 'Font',
    'woff' => 'Font',
    'woff2' => 'Font',
    'htaccess' => 'htaccess'  
  ];
    $aktDir = __DIR__.$_SESSION['aktDir'];
    
    if ($aktDir == __DIR__.'//'){
      $dirContent = array_diff(scandir($aktDir), array('..', '.'));
    }
    else {
      $dirContent = array_diff(scandir($aktDir), array('.'));
    }
  
    foreach ($dirContent as $value){
      if (is_dir($aktDir.$value)){
        $fileExtension = 'Verzeichnis';
        $fileSize = '';
      } else {
      $fileInfo = pathinfo($aktDir.$value);
      $fileExtension = $fileInfo['extension'] ?? null;
      $fileExtension = $myExtension[$fileExtension] ?? $fileExtension; 
      $fileSize = myFileSize(filesize($aktDir.$value)); 
      }
      $fileDate = date("d.m.Y", filemtime($aktDir.$value));  
      $myFiles[]=[
          'filename' => $value, 
          'filetype' => $fileExtension,
          'filesize' => $fileSize,
          'filedate' => $fileDate
      ];
    }
    $aktDir = __DIR__.$_SESSION['aktDir'];
    // filter allowed Files
    if (count($myFiles)){  
      if ($aktDir == __DIR__.'//'){
        $myFiles = array_filter($myFiles, function($el){
          $allowed = ['Verzeichnis', 'Datenbank', 'Icon', 'SQL Dump', 'htaccess'];
          return in_array($el['filetype'], $allowed);
        });
      }
      if ($aktDir !== __DIR__.'//'){
        $myFiles = array_filter($myFiles, function($el){
          $notallowed = ['Datenbank', 'PHP-Datei', 'SQL Dump'];
          return !in_array($el['filetype'], $notallowed);
        });
      }

      usort($myFiles, function($a, $b) {
          return [($a['filetype']!='Verzeichnis'), $a['filename']] <=> [($b['filetype']!='Verzeichnis'), $b['filename']];
      });
    }
    JsonOut([
      'status' => 'OK',
      'message' => 'Verzeichnis gelesen',
      'aktDir' => $_SESSION['aktDir'] ,
      'files' => $myFiles
    ]);
  }
  function renameFile(){
    $filename = $_POST['filename'] ?? '';
    if ($this->config['database']==$filename){
      ErrorOut ( 'aktive Datenbank kann nicht umbenannt werden!');
    }
    $newFilename = $_POST['newfilename'] ?? '';
    //$notAllowedExt = array('php', 'py', 'exe', 'pl', 'sh');
    
    $extOld = pathinfo($filename, PATHINFO_EXTENSION);
    $extNew = pathinfo($newFilename, PATHINFO_EXTENSION);
    if ($extOld != $extNew){
        ErrorOut('unerlaubte Dateierweiterung!'); 
    }
    checkFileExist($filename);
    checkFileInRoot ($newFilename) ;
    checkFileNotExist($newFilename);
    checkFileInRoot ($filename);
    $newFilename =  __DIR__.$_SESSION['aktDir'].$newFilename;
    $filename =  __DIR__.$_SESSION['aktDir'].$filename;
    rename($filename, $newFilename);
    JsonOut([
      'status' => 'OK',
      'message' => 'Umbenannt!',
    ]);
  }
  function renderPage ($site){
    extract($this->getContent($this->config['db'], $site,$this->config['errorsite']));
    
    //changes by fhw
    //echo $html;
    $reg = '/{{insertsite:(?<sitename>.*?)}}/m';
    preg_match_all($reg, $html, $matches, PREG_SET_ORDER, 0);
    //var_export($matches);
    if ($matches){
      foreach($matches as $row){
              
        if ($site !== $row['sitename']) {     
        //echo $row[0].'--'.$row['sitename'].'<br>';
          $tmp = $this->getContent($this->config['db'], $row['sitename'],$this->config['errorsite'])['html'];
          $html=str_replace($row[0], $tmp, $html);
        }
      }
    }
    // end changes fhw
    $myHTML = $html;
    $myReplace = array(
      '{{content}}' => $myHTML,
      '{{keywords}}' => $metakeywords,
      '{{site}}' => $site);
      //'$description' => $metadescription);
      //'$metatitle' => $metatitle);

    $html = strtr($this->getTemplateToRender($template), $myReplace);
    
    
    $html=$this->lookForTextBlocks($this->config['db'],$html);
    
    $html=$this->lookForModules($this->config['db'], $html, $this->config['allowedModFunctions'], $site);
    
    
    
    // check for tempSiteName
    if ($GLOBALS['globSiteName'] !==''){
      $metatitle=$GLOBALS['globSiteName'];
    }
    $html = strtr($html, array('{{metatitle}}' => $metatitle));
    // check for tempdescription
    if ($GLOBALS['globDescription'] !==''){
      $metadescription=$GLOBALS['globDescription'];
    }
    $html = strtr($html, array('{{description}}' => $metadescription));

    return $html;
  }  
  function replaceParameter($parameter, $newValue){
    $myFile = file_get_contents(__FILE__);
    $muster = "/'{$parameter}' => '.*'/";
    preg_match ($muster, $myFile, $match);
    $myFile = str_replace($match[0]??'',"'{$parameter}' => '".$newValue."'", $myFile);

    $isWrite= file_put_contents(__FILE__, $myFile);

    if ($isWrite != false){
      JsonOut([ 
            'status' => 'OK',
            'message' => $newValue,
            'size' => $isWrite
            ]);
    } else {
        ErrorOut('Beim Schreiben ist ein Fehler aufgetreten');
        /*
        JsonOut([ 
            'status' => 'Error',
            'message' => "Beim Schreiben ist ein Fehler aufgetreten",
            'size' => $isWrite
            ]);
        */
    }
  }
  function save(){
    $table = $_POST['table'] ?? null;
    $action = $_POST['action'] ?? null;
    $rowid = $_POST['rowid'] ?? null;
    $todo = ($rowid=='') ? 'new' : 'update';
    unset($_POST['rowid']);
    unset($_POST['action']);
    unset($_POST['table']); 
    if(fieldTest($this->config['db'], $table, $_POST)){
      if ($todo == 'update'){  
        $query = 'update '.$table;
        $query .= ' set ';
        foreach ($_POST as $key => $value) $query.= $key.'= :'.$key.' ,';
        $query = substr($query, 0, -1);
        $query.='where rowid = :rowid';
        $_POST['rowid'] = $rowid;
        $ret = execQuery($this->config['db'], $query, $_POST);
        JsonOut($ret);
      }
      if ($todo == 'new'){
        $query = 'insert into '.$table.' (';
        foreach ($_POST as $key => $value) $query.= $key.' ,';
        $query = substr($query, 0, -1);
        $query .= ') values ( ';
        foreach ($_POST as $key => $value) $query.= ':'.$key.' ,';
        $query = substr($query, 0, -1);
        $query.=')';
        $ret = execQuery($this->config['db'], $query, $_POST);
        JsonOut($ret);
      }
    } else {
      ErrorOut('fehlerhafte Felddeklaration!');
    }
  }
  function saveStylesheet () {
    checkFileExist($_POST['filename']);
    checkFileInRoot ($_POST['filename']);
    $allowedExt = array('css', 'js', 'htaccess');
    checkFileExtension ($_POST['filename'], $allowedExt);
    $textcontent = $_POST['textcontent'] ?? null;
    if ($textcontent){
      file_put_contents(__DIR__.$_SESSION['aktDir'].$_POST['filename'], $textcontent);
      JsonOut(['status' => 'OK','message' => 'Datei geändert']);
    }
    ErrorOut ('Konnte Datei nicht schreiben !');
  }
  function sqlDump() {
    $_SESSION['aktDir'] = '//';
    $database = $_POST['database'] ?? '';
   
    if ($database !== ''){
     
      checkFileExist($database);
      checkFileInRoot($database);
      $dbfile = __DIR__.'/'.$database;
      try {$db = new PDO('sqlite:'.$dbfile);}      
      catch(PDOException $e){
        ErrorOut ($e->getMessage());
      }
    }
    $tables = $_POST['tables'] ?? '';
    if ($tables !== ''){
      $tablesArray = explode (',', $tables);
      forEach($tablesArray as $table){
        if(!fieldTest($db, $table)){
          ErrorOut('Tabelle nicht vorhanden!');
        }
      }
      //wenn bis hierhin alles gut, kann es losgehen
      $this->exportSQLite($db, $database, $tablesArray);  
      
      
      
    }
    
    
    
    JsonOut([
      'status' => 'OK',
      'message' => 'SQLDUMP',
      'Post' => $_POST,
      'tables' => $tablesArray
    ]);
    
    
    
  }
  function sqlEdit() {
    $query = $_POST['sql'] ?? '';
    if ($query !== ''){
      JsonOut(execQuery($this->config['db'], $query));
    }  
  }
  function sqlImport(){
    $_SESSION['aktDir'] = '//';
    $sqlFile = $_POST['sqlFile'] ?? '';
    $database = $_POST['database'] ?? '';
    if ($sqlFile !== ''){
      checkFileExist($sqlFile);
      checkFileInRoot($sqlFile);
    }
    if($database !== ''){
      checkFileExist($database);
      checkFileInRoot($database);
    }
    // bis hierhin ist alles gut!!
    $dbfile = __DIR__.'/'.$database;
    try {$db = new PDO('sqlite:'.$dbfile);}      
    catch(PDOException $e){
      ErrorOut ($e->getMessage());
    }
    // jetzt SQL Lesen
    $impQuery = file_get_contents(__DIR__.$_SESSION['aktdir'].$sqlFile);
    
    $isGood = $db->exec($impQuery);
    if ($isGood !==false){
      JsonOut([
        'status' => 'OK',
        'message' => 'SQLImport erfolgreich'
    ]);
    }
    ErrorOut ('import fehlgeschlagen');
  }
  function upload () {
  $allowed_ext = [
    'ico', 'jpg', 'jpeg', 'png', 'gif', 'svg', 'svgz', 
    'apng', 'webp', 'avif', 'mp4', 
    'js', 'css', 'pdf', 'htaccess', 'eot', 'ttf', 'woff', 'woff2',
    'json', 'doc', 'docx', 'xls', 'xlsx'
  ];
  $allowed_ext_root = [
    'htaccess', 'ico','sql', 'sqlite'
  ];
  $message = '';
  $sendfiles = count($_FILES['files']['tmp_name']) ?? null;
  for ($i = 0; $i < $sendfiles; $i++) {
    $file_name = strtolower($_FILES['files']['name'][$i]);
    $file_name  = str_replace(' ', '-', $file_name);
    $file_tmp = $_FILES['files']['tmp_name'][$i];
    $file_type = $_FILES['files']['type'][$i];
    $file_size = $_FILES['files']['size'][$i];
    if ($file_size > 3000000){ ErrorOut( 'Dateigröße überschritten -> '.$file_name);}
    $tmp = explode('.', $file_name);
    $file_ext = end($tmp);
    if ($_SESSION['aktDir'] == '//'){
      $allowed_ext = $allowed_ext_root;
    }
    if (in_array($file_ext, $allowed_ext)){
      checkFileNotExist($file_name);
      checkFileInRoot($file_name);
      move_uploaded_file($file_tmp, __DIR__.$_SESSION['aktDir'].$file_name);
    } else {
      $message .= $file_name.' -> nicht erlaubt'.PHP_EOL;
    }
  }
  if ($message=='') $message = 'Upload erfolgreich';
  JsonOut([
    'status' => 'OK',
    'message' => $message
  ]);
}
  function update() {
    function replPar($parameter, $newValue, $content){
      $muster = "/'{$parameter}' => '.*'/";
      preg_match ($muster, $content, $match);
      $content = str_replace($match[0]??'',"'{$parameter}' => '".$newValue."'", $content);
      return $content;
    }
    $newFile = @file_get_contents($this->config['updateUrl']);  
    $newFile=replPar('user', $this->config['user'], $newFile);
    $newFile=replPar('pass', $this->config['pass'], $newFile);
    $newFile=replPar('database', $this->config['database'], $newFile);
    $newFile=replPar('startsite', $this->config['startsite'], $newFile);
    $newFile=replPar('errorsite', $this->config['errorsite'], $newFile);
    $newFile=replPar('detailblog', $this->config['detailblog'], $newFile);
    $newFile=replPar('getAdmin', $this->config['getAdmin'], $newFile);
    
    if ($newFile){
        $isWrite = @file_put_contents(__FILE__, $newFile);
        if (!$isWrite){
          ErrorOut('konnte Datei nicht schreiben!');
        }
        JsonOut([
          'status' => 'OK',
          'message' => 'Update erfolgreich !'
    ]);
      
    } else {
      ErrorOut('Update Datei wurde nicht gefunden!');
    }
 }
  function vacuum () {
    $myQuery=$this->config['db']->prepare("VACUUM");
    $isOk = $myQuery->execute();
    if ($isOk==true){
        $myReturn = [ 
          'status' => 'OK',
          'message' => 'Datenbank erfolgreich optimiert!'
      ];
      JsonOut($myReturn);
    }
    
    ErrorOut('konnte Datenbank nicht komprimieren!');
  }
}

if (isset($_GET[$myConfig['getAdmin']])){
  $verwaltung=true;  
}
else {  
  $verwaltung=false;
  $myAdmin = new musadmin($myConfig, $_POST);
  $myAdmin->handleAction(); 
}
if ($verwaltung==true){
  /*begin htm*/?>
<!DOCTYPE html>
<html lang="de">
<head>
  <meta charset="UTF-8">
  <title>Document</title>
  <meta name=viewport content="width=device-width, initial-scale=1">
  <!--begin css--><!--end css-->
  <!--begin js--><!--end js-->
  <style>
:root{
  --header-height: 70px;
  --footer-height:50px;
  --max-width: 768px;
  --primary: hsl(195deg, 85%, 41%);
  --primary-dark: hsl(195deg, 85%, 30%);
}

*{
  font-family:  -apple-system, "Segoe UI", Roboto, Helvetica, Arial, sans-serif;
  box-sizing: border-box;
  font-size: 18px;
  line-height:1.2em;
  margin:0;
 
}

@media screen and (max-width: 768px){
  *{
    font-size:14px;
  }
}

[data-action] {cursor:pointer;}
.hidden{display:none;}
.thhidden{display:none;}

/* Layout */
html{
  margin:0;
  padding.0;
  box-sizing:border-box;
}


html,body{
  min-height:100vh;
}


body{
  position:relative;
  width: clamp(300px, 90%, var(--max-width));
  margin:0 auto;
}
main{
  padding-top:var(--header-height);
  padding-bottom: calc(var(--footer-height) + 20px);
  
}

header{var(--header-height);
  position: fixed;
  width:inherit;
  border-bottom:1px solid silver;
  background: white;
}
header>div{
  display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: flex-end;
    align-content: flex-end;
    align-items: flex-end;
  height:var(--header-height);
}
header>div h3{
  min-width:100%;
  display:block;
  color:red;
  font-size:2em;
}

header, .cards, h1, h2, h3, button{
    user-select:none;
}
footer{
  width:100%;
  position:absolute;
  height: var(--footer-height);
  bottom:0;
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;
  border-top:1px solid silver;
}

main > div {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: space-between;
}
/*navigation*/
nav{align-self: flex-end;}
nav ul{
  z-index:1;
  padding-bottom:.5em;
  display:flex;
  gap: .5em;
  list-style-type:none;
}

nav ul li {
  font-size: 1.5em;
  transition: all .2s ease-in-out;
}
nav ul li:hover{transform: scale(1.5);}
@media screen and (max-width: 768px){
  nav ul li{
    font-size: 1.75em;
  }
}




/* font-sizes */
h1{
  font-size:2em;
  font-weight:500;
  text-transform: uppercase;
  color: var(--primary-dark);
  letter-spacing: 2px;
}
@media screen and (max-width: 768px){
  h1{
    font-size: 1.75em;
    letter-spacing: 1px;
  }
}


h2{font-size:1.5em;}
/* use for all */
.max{width:100%; margin:.75em auto;;}
.half{min-width:45%;display: inline-block;}
/* cards home screen */
.cards{
  min-width:31%;
  max-width:31%;
  /*border:2px solid #eee;*/
  border-radius:0.5em;
  margin-top:2em;
  padding:1em 0.5em;
  box-shadow: rgba(150,150,150, 0.5) 1px 2px 6px ;
  text-align:center;
  background: #fcfcfc;
}

.cards:hover{
  box-shadow: rgba(150,150,150, 0.5) 1px 2px 6px inset;
  background: #fafafa;
}


.cards p:first-of-type{
  font-weight:bold;
}

.cards p:last-of-type{
  font-size:0.875em;
  margin-top: .8em;
}
.cards h3{
  font-size:2em;
  margin-bottom:0.5em;
}
 
@media screen and (max-width: 680px){
  div.cards{
    min-width:48%;
    width:48%;
  }
  .cards p{
    font-size:.875em;
  }

}

/* Übersichten */
.title-search{
  display:flex;
  width:100%;
  justify-content: space-between;
  padding:1em 0;
}
.title-search input{
  min-width:45%;
  max-width:45%;
}

[data-action="setConfirm"]{
  color:green;
}
dialog:not([open]) {
  display: none;
}

dialog::backdrop { 
  background-image: linear-gradient(to right, rgba(182,251,255,0.5),rgba(131,164,212,0.5));
  backdrop-filter: blur(2px);
}

dialog[open]{
  display:flex;
  flex-direction: column;
  flex-wrap: wrap;
  padding:0;
  margin:auto;
  min-width: 360px;
  max-height:90%;
  width:90%;
  max-width:450px;
  box-sizing: border-box;
  border:none;
  border-radius: 10px;
  box-shadow: rgba(0, 0, 0, 0.19) 0px 10px 20px, rgba(0, 0, 0, 0.23) 0px 6px 6px;
  animation-duration: 0.3s;
  animation-name: fadeIn;
}

@keyframes fadeIn {
  0% {transform: scale(0.3);}
  70% {transform: scale(1.1);}
  100%{transform: scale(1);}
}

dialog header, 
dialog footer {
  position: relative;
  margin:0;
  border:none;
  padding:1em;
  height:auto;
}
dialog header{
  background: white;
  margin-top:1em;
}
dialog>div{
  padding:0em 1em;
}
dialog div label{
  display:block;
  margin-top:2em;
  width:100%;
  font-weight: bold;
}
dialog div label:last-of-type{
  margin-bottom: 2em;
}

dialog footer {
  background: white;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
  
}
dialog footer button{
  margin:0;
  cursor:pointer;
}
dialog h2{
  margin:0;
  padding:0;
  line-height: 1.25em;
  font-size:1.5em;
  
  font-weight:500;
  text-transform: uppercase;
  color: var(--primary-dark); 
}
dialog:has(button[hidden]) button:last-child{
  margin-left:50%;
}

dialog form label:has([type="checkbox"]){
  display:flex;
  flex-direction: row;
  justify-content: space-between;
  align-items: center;
  margin-top: 1.5em;
  padding:0;
}
dialog form label:has([type="checkbox"]) p{
  font-size: 1.75em;
}
dialog form input[type="checkbox"]{
  width:30px;
  height: 30px;
  display:block;
}

dialog form input[type="checkbox"]{
 accent-color: blue;
}

dialog form input[type="text"],
dialog form input[type="password"]{
 font-size:1.5em;
  font-weight:bold;
}

label:has([type="checkbox"]){
  font-size:1.2em;
}

dialog h1{
  font-size:1.2em;
  font-weight:500;
  text-transform: uppercase;
  color: var(--primary-dark);
  letter-spacing: 2px;
}


dialog:has([name="mysqleditor"]){
  min-width:90%;
  min-height:90%;
}
dialog:has([name="mysqleditor"])>div{
  flex:1 1 auto;
  position:relative;

}

dialog:has([name="mysqleditor"]) form{
  position:absolute;
  left:10px;
  right:10px;
  bottom:10px;
  top:10px;
}
dialog:has([name="mysqleditor"]) textarea{
  height:100%;
}
/*
dialog[open]{
  padding: 1em;
  margin: auto;
  width:50%;
  min-width: 350px;
  max-width:500px;
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: space-between;
  border:none;
  border-radius: 10px;
  box-shadow: rgba(0, 0, 0, 0.19) 0px 10px 20px, rgba(0, 0, 0, 0.23) 0px 6px 6px;
}

dialog div{
  margin: 1.5em 0 0 0 ;
  width:100%;
}

dialog:has(button[hidden]) button:last-child{
  margin-left:50%;
}
dialog form input{
  margin-bottom: 1em
}

dialog h2{
  line-height:1.25em
}

dialog form label:has([type="checkbox"]){
  width:50%;
  font-weight:bold;
}
*/
th{
  text-align:left;
}
td:last-child{
  font-size:1.25em;
}
table{
  background: white;
  border-collapse: collapse;
  width:100%;
}
thead tr{
    border-top: 1px solid #adadad;
  }
tr{
  display: flex; 
  flex-direction: row;
  flex-wrap: wrap;
  align-items: center;
  border-bottom: 1px solid #dadada;
}
th{
  padding:0.5em 0;
}
td{ 
  padding: 0.25em 0;
}
tbody{
  display:block;
  height:250px;
  overflow-y:auto;
}

tbody tr:hover{
  background:#fafafa;
}
table[data-table] th:last-child,
table[data-table] td:last-child{
  width:30px;  
  text-align:center;
}

table[data-table="websites"] th:nth-child(1),
table[data-table="websites"] td:nth-child(1){
  width:150px;    
}
table[data-table="websites"] th:nth-child(2),
table[data-table="websites"] td:nth-child(2){
  width:150px;    
}
table[data-table="websites"] th:nth-child(3),
table[data-table="websites"] td:nth-child(3){
  flex: 1 1 200px;
}

table[data-table="news"] th:nth-child(1),
table[data-table="news"] td:nth-child(1){
  width:180px;    
}
table[data-table="news"] th:nth-child(2),
table[data-table="news"] td:nth-child(2){
  flex: 1 1 200px;
}
table[data-table="textblocks"] th:nth-child(1),
table[data-table="textblocks"] td:nth-child(1){
  width:180px;    
}
table[data-table="textblocks"] th:nth-child(2),
table[data-table="textblocks"] td:nth-child(2){
  flex: 1 1 200px;
}
table[data-table="templates"] th:nth-child(1),
table[data-table="templates"] td:nth-child(1){
  width:200px;    
}
table[data-table="templates"] th:nth-child(2),
table[data-table="templates"] td:nth-child(2){
  flex: 1 1 200px; 
}

@media screen and (max-width: 550px){
  table[data-table="websites"] th:not(:first-child, :last-child),
  table[data-table="websites"] td:not(:first-child, :last-child){
    display:none;
  }
  table[data-table="websites"] td:first-child{
    flex: 1 1 80%;
  }
  
  table[data-table="news"] th:not(:nth-of-type(2), :last-child),
  table[data-table="news"] td:not(:nth-of-type(2), :last-child){
    display:none;
  }
  table[data-table="news"] td:nth-of-type(2){
    flex: 1 1 80%;
  }  
  
  table[data-table="textblocks"] th:not(:nth-of-type(2), :last-child),
  table[data-table="textblocks"] td:not(:nth-of-type(2), :last-child){
    display:none;
  }
  table[data-table="textblocks"] td:nth-of-type(2){
    flex: 1 1 80%;
  }  
  
  table[data-table="templates"] th:not(:nth-of-type(2), :last-child),
  table[data-table="templates"] td:not(:nth-of-type(2), :last-child){
    display:none;
  }
  table[data-table="templatess"] td:nth-of-type(2){
    flex: 1 1 80%;
  }  
  
}
@media screen and (max-width: 767px){
  table[data-table="websites"] th:not(:first-child, :last-child, :nth-of-type(3)),
  table[data-table="websites"] td:not(:first-child, :last-child, :nth-of-type(3)){
    display:none;
  }
  table[data-table="websites"] td:nth-of-type(3){
    flex: 1 1 auto;
  }

}


/*
@media screen and (max-width: 550px){
  table[data-table="websites"] th:nth-child(2),
  table[data-table="websites"] td:nth-child(2),
  table[data-table="textblocks"] th:nth-child(2),
  table[data-table="textblocks"] td:nth-child(2),
  table[data-table="templates"] th:nth-child(2),
  table[data-table="templates"] td:nth-child(2),
  table[data-table="news"] th:nth-child(1),
  table[data-table="news"] td:nth-child(1),
  table[data-table="websites"] th:nth-child(3),
  table[data-table="websites"] td:nth-child(3)
  {
    display:none;
  }
  table[data-table="websites"] td:nth-child(1),
  table[data-table="templates"] td:nth-child(1),
  table[data-table="textblocks"] td:nth-child(1){
    flex:1 1 auto;
  }
}
@media screen and (max-width: 650px){
  table[data-table="websites"] th:nth-child(2),
  table[data-table="websites"] td:nth-child(2),
  table[data-table="textblocks"] th:nth-child(2),
  table[data-table="textblocks"] td:nth-child(2),
  table[data-table="templates"] th:nth-child(2),
  table[data-table="templates"] td:nth-child(2),
  table[data-table="news"] th:nth-child(1),
  table[data-table="news"] td:nth-child(1). 
  table[data-table="websites"] th:nth-child(3),
  table[data-table="websites"] td:nth-child(3)
  {
    display:none;
  }
  table[data-table="websites"] td:nth-child(2),
  table[data-table="templates"] td:nth-child(1),
  table[data-table="textblocks"] td:nth-child(1){
    flex:1 1 auto;
  }
}
*/


#filemanager th:nth-child(1),
#filemanager td:nth-child(1) {
  width:250px;
}
#filemanager th:nth-child(2),
#filemanager td:nth-child(2) {
  width:160px;
}
#filemanager th:nth-child(3),
#filemanager td:nth-child(3) {
  width:140px;
}
#filemanager th:nth-child(4),
#filemanager td:nth-child(4) {
  flex:1 1 100px;
}
#filemanager th:nth-child(5),
#filemanager td:nth-child(5) {
  width:30px;
  text-align:center;
  font-size: 1.25em;
}
#filemanager th:last-child,
#filemanager td:last-child{
  width:30px;  
  text-align:center;
  font-size: 1.25em;
}
#filemanager th,
#filemanager td{
  text-align:left;
}
tr:has([data-filetype="DIR"]) td:first-child,
tr:has([data-filetype="DIR"]) td:nth-child(2){
  font-weight:bold;
}

@media screen and (max-width: 550px){
  #filemanager th:not(:first-child, :last-child, :nth-last-of-type(2)),
  #filemanager td:not(:first-child, :last-child, :nth-last-of-type(2)){
    display:none;
  }
  #filemanager td:first-child,
  #filemanager th:first-child{
    flex: 1 1 70%;
    
  }
}


@media screen and (max-width: 767px){
  #filemanager th:not(:first-child, :last-child, :nth-of-type(2), :nth-last-of-type(2)),
  #filemanager td:not(:first-child, :last-child, :nth-of-type(2), :nth-last-of-type(2)){
    display:none;
  }
  #filemanager td:nth-of-type(2),
  #filemanager th:nth-of-type(2){
    flex: 1 1 auto;
  }
  #filemanager td:nth-of-type(1),
  #filemanager th:nth-of-type(1){
    width: 200px;
  }
}

@media screen and (min-width: 768px){
  
  #filemanager td:nth-of-type(4),
  #filemanager th:nth-of-type(4){
    flex: 1 1 auto;
  }

}

#filemanager{
  user-select:none;
}
#filemanager tbody{
  height:250px;
}
p:has(#filemanagerPath){
  display:block;
  width:100%;
 
  margin-bottom:1em;
}
p:has(#filemanagerPath) span{
  font-weight:bold;
  font-size:1.2em;
}

dialog:has([data-picpreview]){
  min-width:90vw;
  max-width:90vw;
  min-height:90vh;
  max-height:90vh;
  display: grid;
  grid-template-rows: auto 1fr auto;
}
dialog:has([data-picpreview])>div{
   width:100%;
  height:100%;
}
dialog:has([data-picpreview])>div>div{
  min-width:100%;
  min-height:100%;
  display: grid;
  place-items: center;
  
}
dialog:has([data-picpreview]) img{
  max-width:100%;
}
dialog:has([data-picpreview]):not([open]) {
  display: none;
}

dialog:has([data-textedit]) div{
   width:100%;
  height:100%;
  padding-bottom: 1em;
}

dialog:has([data-textedit]) textarea{
  min-width:100%;
  height: 90%;
  box-sizing: border-box;
}



/*

dialog:has([data-picpreview]){
  min-width:90%;
  max-width:90%;
  max-height:80vh;
  min-height: 80vh;
  width:70%;
}


dialog:has([data-picpreview]) img{
  max-width: 100%;
  max-height:70vh;
  margin: auto;
  display: block;
}
*/

[data-screen="filemanagerScreen"]>div{
  width:100%;
}

/*
[data-action] {cursor:pointer;}
.hidden{
  display:none;
}

main > div {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
  justify-content: space-between;
}


h1, h2 {
  width:100%;
}
h1{font-size:1.5em;line-height: 2em;}
h2{font-size:1.25em;line-height:1.75em;}
*/
label{
  width:48%;
  line-height: 0.75em;
  font-size:0.75em;
}
label:has(textarea){
  width:100%;
}
[for="textblocks-description"]{
  width:100%;
}

input, select, textarea, button
{
  width:100%;
  padding: 0.25em;
  font-size:1.25em;
  margin-top:0.25em;
}

button{
  width:48%;
  font-weight:bold;
  font-size: 1em;
}
label, button{
  margin-top: 1em;
}
/*
[data-screen="home"]>div,
[data-screen="settings"]>div{
  width:30%;
  text-align:center;
  padding: 2em 0 2em 0;
}
*/
table{
  width:100%;
}

textarea{
  height: 200px;
  font-family: monospace;
  font-size:1.25em;
  resize: vertical;
}

input:invalid,
textarea:invalid{
  /*background: #fee;*/
  border: 2px solid red;
}


header h3{
  font-size:2em;
  align-self: center;
}
footer p{
  font-weight: bold;
  font-size: 0.875em;
  text-transform: uppercase;
}

@media screen and (max-width: 767px) {
  label{
    width:100%;
  }
}
.title-search{
  width:100%;
  display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    justify-content: space-between;
    align-content: center;
    align-items: center;
    margin-bottom:1em;
}

.title-search input{
  display:block;
  width:80%;
}#previewCMS:not([open]) {
  display: none;
}

#previewCMS{
  display:block;
  position: absolute;
  left:0;
  top:0;
  min-width:90%;
  max-width:90%;
  min-height:90vh;
  max-height:90vh;
  display: flex;
  flex-direction: column;
  flex-wrap: nowrap;
  justify-content: space-between;
  align-content: stretch;
  align-items: flex-start;
  background:white;
  z-index:9999;
}
#previewCMS div{
  width:100%;
  /*max-width:768px;*/
  margin:auto;
}
#previewCMS div:nth-last-of-type(2){
  flex:1 1 auto;
  position:relative;
}
#previewCMS button{
  margin-bottom: 1em;
  font-size:1em;
}
#previewCMS h1{
  line-height:2em;
  padding:0em;
  margin:0em;

}
#previewCMS iframe{
  position:absolute;
  width:100%;
  height:100%;
  left:0;
  border:none;
  
}
#previewCMS div:last-of-type{
  display: flex;
  flex-direction: column;
  align-content: stretch;
  align-items: flex-end;
}
[data-thowner]{
  display:flex;
  flex-direction:row;
  margin-top:0.25em;
}
[data-thowner]>p{
  padding:0.25em;
  
}
[data-thowner]>p:hover{
 color:gray;
  background: #eee;
  border-radius:5px;
}
.thhidden{
  display:none;
}
[data-para="bold"]{font-weight:bold;}
[data-para="italic"]{font-style:italic;font-weight:bold;}
[data-para="linethrough"]{text-decoration: line-through;font-weight:bold;}
[data-para="code"]{font-family:monospace;font-weight:bold;}
dialog:has([data-textedit]){
  min-width:95%;
  max-width:95%;
  height:95vh;
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}
dialog:has([data-textedit]) div {
  flex: 1 1 200px;
}
dialog:has(div [data-textedit]) textarea{
  height:100%;
  font-size: 1em;
}
dialog:has([data-textedit]):not([open]) {
  display: none;
}

.editor-max{
  position:absolute;
  top:0px;
  background: white;
  left:0px;
  bottom:0px;
  right:0px;
  z-index:100;
  display:flex;
  flex-direction: column;
  align-items: flex-start;
  margin:0px;
}
.editor-max textarea{
  flex: 1 1 200px;
}

button{
  position:relative;
  font-weight:400;
      text-transform: uppercase;
      margin:1.5em 0em 0em 0em;
      padding:.75em;
      box-shadow: 2px 3px 4px rgba(0,0,0,0.4);
      transition: all 200ms ease;
      background: var(--primary);
      border:none;
      color:white;
  letter-spacing: 2px;
}
button:active{
  box-shadow:none;
}
</style>
</head>
<body>
<header>
  <div>
    <nav>
      <ul>
         <li data-action=show data-screen=home data-title="Homescreen">🏠
         <li data-action=show data-screen=filemanagerScreen data-title='Dateimanager'>📂
         <li data-action=show data-screen=settings data-title='Einstellungen'>⚙
         <li data-action=logout data-screen=home data-title='Logout'>🔒
      </ul>
    </nav>
  </div>
</header>
<main>
</main>
<footer><p>FHW-CMS-2022</p></footer>
<script>
"use strict"; 
const $ = function (selector = null) {
 class selection {
  constructor(selector) {    
   if (selector) {
    this.nodes =
     selector === document ? [document] :
     selector === window ? [window] :
     selector.nodeType ? [selector] :
     selector.constructor.name==this.constructor.name ? selector.nodes :
     NodeList.prototype.isPrototypeOf(selector) ? selector :
     document.querySelectorAll(selector)
     this.n=this.nodes[0] 
   }
  }
   
  
   
   
    // iteriere durch NodeList
  each = callback => (this.nodes.
   forEach( (_node, index) => callback(_node, index)), this)

  /**************/
  /*** ready ****/
  /**************/
    // warte bis Dokument geladen ist
    // $().ready( () => console.log('ferig'))
  ready = callBack => 
    document.addEventListener('DOMContentLoaded', callBack , false)
  
  
  /*****************/
  /**** Classes ****/
  /*****************/

    // setze eine oder mehrere Klassen
    // $('h1').addClass('red , blue')
  addClass = ( ...classes ) => this
    .each( _node =>
      _node.classList.add( ...classes ) )
  
    // entfernt eine oder mehrere Klassen
    // $('h1').removeClass('red , blue')
  removeClass = ( ...classes ) => this
    .each( _node =>
      _node.classList.remove( ...classes ) )
  
    // ersetzt eine Klasse
    // $('h1').replaceClass('red , blue')
  replaceClass = (class1, class2) => this
    .each( (_node) =>
      _node.classList.replace(class1,class2)) 
  
  
    // toggelt eine Klasse
    // $('h1').toggleClass('red')
  toggleClass = ( _class ) => this
      .each( (_node) => 
      _node.classList.toggle( _class ))
  
    // check ob Element eine bestimmte
    // Klasse besitzt
    // $('p').hasClass('red') -> true or false
  hasClass = _class => this.n.classList.contains(_class)

  /*****************/
  /**** Content ****/
  /*****************/
  
    // ersetzt HTML in Node oder 
    // gibt innerHTML zurück wenn (html) nicht übergeben wird
    // $('div').html('<h1>Test</h1>')
    // let divContent = $('div').html()
  html = (html=null) => (html !== null )
    ? this.each( (_node) => _node.innerHTML = html)
    : this.n.innerHTML
  
    // ergänzt html in angegebenen Nodes
    // an folgenden Positionen
    // - beforebegin
    // - afterbegin
    // - beforeend (default Einstellung)
    // - afterend
    // $( 'div' ).insHtml( "<p>Lorem Ipsum..</p>", "afterbegin" )
  insHtml = (html, pos="beforeend") =>
    this.each( (_node) => _node
      .insertAdjacentHTML( pos, html ))

    // ersetzt innerText in Node oder 
    // gibt innerText zurück wenn (text) nicht übergeben wird
    // $('h1').text('myHeader')
    // let h1Text = $('h1').text()
  text = (text=null) => (text!==null)
    ? this.each( (_node) => _node.innerText = text)
    : this.n.innerText

  /***************/
  /**** Nodes ****/
  /***************/
  
    // erstellt ein leeres Element
    // und gibt dieses zurück
    // let newNode = $().create('h1')
  create = tag => $(document.createElement(tag))
    
    // erstellt eine Kopie des übergebenen
    // Elementes und gibt diese zurück
    // $('p').clone().addClass('red')
    // .insertAfter($('p'))
  clone = () => $(this.n.cloneNode(true))
    
    // erstellt ein neues Element
    // fügt dieses Element an das Ende des 
    // übergebenene Elementes ein
    // und gibt dieses zurück
    // $('div').append('h3').text('new H3')
  append = tag => {
    let newEl = this.create(tag)
    this.n.appendChild(newEl.n)
    return newEl
  }
    // let body = $('body)
    // let h2 = $().create('h2').text('h2Text')
    // let h3 = $().create('h3').text('h3Text')
    // body.sAppend(h2).sAppend(h3)
  sAppend = el => {
    this.n.append(el.n)
    return this
  }
    // fügt Element an das Ende des 
    // übergebenene Elementes ein
    // und gibt dieses zurück
    // dummy=$().create('h2')
    // .text('new H2').appendEnd($('body'))
  appendEnd = _node => $(_node.n
    .appendChild(this.n)) 
  
    // fügt Element vor dem 
    // übergebenenen Element ein
    // und gibt dieses zurück
    // dummy=$().create('h1')
    //  .text('new H1')
    //  .insertBefore($('h2'))
  insertBefore = _node => ($(_node).n
    .before(this.n),this) 
  
    // fügt Element nach dem 
    // übergebenenen Element ein
    // und gibt dieses zurück
    // dummy=$().create('h2')
    //  .text('new H2')
    //  .insertAfter($('h1'))  
  insertAfter = _node => ($(_node).n
    .after(this.n),this)
  
    // entfernt Element(e) aus dem DOM
    // $('p').remove() gibt nichts zurück
  remove = () => this
    .each((_node) => _node.remove()) 
  
    // gibt das Elternelement zurück
    // ist tag gesetzt, wird das nächste
    // elternelement mit dem angegebenen 
    // tag zurückgegeben
    // $('h1).parent() 
    // $('p').parent('div')
  
  
  parent = tag => tag
    ? $(this.n.closest(tag))
    : $(this.n.parentElement)
    //closest = this.parent
    // gibt Elemente unterhalb des
    // 1. übergebenen Nodes zurück
    // $('.container').find('p')
  find = tag => $(this.n.querySelectorAll(tag))
                  
    // gibt erstes Element zurück
    // $('p').first().addClass('red')
  first = () => $(this.n)
  
    // gibt letztes Element zurück
    // $('p').last().addClass('red')
  last = () => $(this.nodes[this.nodes.length-1])
  
    // gibt Element[index] zurück
    // $('p').index(1).addClass('red')
  index = index => $(this.nodes[index])
  
    // check ob Element exisitiert
    // $('p').exist() -> true oder false
  exist = () => (this.nodes.length > 0) ? true : false
  
    // check ob text in Element vorhanden ist
    // $('p').contains('lorem')
    // gibt Nodeliste der entsprechenden Elemente zurück
  contains = text => {
    this.nodes.forEach ( (_node )=> {
      if(_node.innerText.includes(text)){
        $(_node).setAttr('myqueryfound')
      }
    })
    return $('[myqueryfound]').removeAttr('myqueryfound')
  }
  
    //selectiert alle Nodes zwischen zwei Nodes
    // und gibt diese zurück
    // $('h2').between($('h3'))
  between = endNode => {
    if ($(endNode).nodes.length==0) return this
    let  el = this.n.nextElementSibling
    while (el !== $(endNode).n){
      $(el).setAttr('myqueryfound') 
        el = el.nextElementSibling
    }
    return $('[myqueryfound]').removeAttr('myqueryfound')
  }
  
  
  /*******************/
  /**** Attribute ****/  
  /*******************/

  // setzt Attribute der Elemente
  // $('button').setAttribute(disabled)
  // $('input').setAttr('placeholder', 'my placeholder')
  setAttr = (key,value='') => this.each((_node) => _node
    .setAttribute(key,value))
  
  // gibt Attribute des ersten Elements zurück
  // myAttribute = $('input').getAttr('placeholder)
  getAttr = att => this.n.getAttribute(att)
  
  // löscht Attribute der angegebenen Elemente
  // $('input').removeAttr('placeholder)
  removeAttr = att => this.each((_node) => _node
    .removeAttribute(att))
  
  // check ob Element ein bestimmtes
  // Attribut besitzt
  // $('input').hasAttr('placeholder') -> true or false
  hasAttr = att => this.n.hasAttribute(att)
  
  /******************/
  /**** Datasets ****/  
  /******************/  
  
  // setzt Dataset der angegebenen Elemente 
  // $('button').setData('action', 'getArticles')
  setData = (key,value) => this.each((_node) => _node
    .dataset[key]=value) 
  
  // gibt Dataset Wert des angegebenen 
  // Elementes zurück
  // $('button').getData('action')
  getData = key => this.n .dataset[key] 
  
  // löscht Dataset Wert der angegebenen 
  // Elemente und gibt diese zurück
  // $('button').removeData('action')
  removeData = key => this.each((_node) => delete _node
    .dataset[key]) 
  
  // check ob Element ein bestimmtes
  // Data Attribut besitzt
  // $('button').hasData('action') -> true or false
  hasData = att => att in this.n.dataset

  /****************/
  /**** events ****/  
  /****************/ 
  
  // bindet den EventListener 'click'
  // an die angegebenen Elemente,
  // führt nach Auslösung die
  // angegebene CallBack Function aus
  // und gibt Elemente zurück
  // $('button').click(doSomething)
  click = callBack => this.each((_node) => _node
    .addEventListener('click', callBack))
  
  // löscht den EventListener 'click'
  // der angegebenen Elemente.
  // Achtung keine anonymen Funktionen
  // verwenden!!
  // $('button').removeClick(doSomething)
  removeClick = callBack => this
    .each((_node) => _node
    .removeEventListener('click', callBack))
  
  // bindet den EventListener 'event'
  // an die angegebenen Elemente,
  // führt nach Auslösung die
  // angegebene CallBack Function aus
  // und gibt Elemente zurück
  // $('button').on('click', doSomething)
  on = (evt,callBack, options=null) => this
    .each((_node) => _node
    .addEventListener(evt, callBack, options))
  
  // löscht den EventListener 'evt'
  // der angegebenen Elemente.
  // Achtung keine anonymen Funktionen
  // verwenden!!
  // $('button').removeOn(doSomething)
  removeOn = (evt,callBack) => this
    .each((_node) => _node
    .removeEventListener(evt, callBack))

  /****************/
  /**** styles ****/  
  /****************/   
  
  // hier sollte man nicht mehr Eigenschaften 
  // anwenden, der Weg über Klassen ist besser.
  
  // zeigt angegebene Elemente nicht mehr an
  // $('p').noDisplay()
  noDisplay = () => this.each((_node) => _node
    .style.display='none')
  
  // zeigt angegebeneElemente an
  // $('p').display()
  display = () => this.each((_node) => _node
    .style.display=null)
  
  // set multiple Styles Chain return Proxy
  // for first found Element
  //$('p').mStyles().fontWeight('bold').color('red').fontSize('25px')
  // for multiple Elements:
  /*  $('p').each( el =>        
        $(el)
          .mStyles()
            .color('red')
            .fontWeight('bold')
            .border('1px solid gray')
            .padding('1em')
          .parent()
            .addClass('lll'))*/
  styles = () => {
    let myProxy = new Proxy(this.n.style, myStyles)
    myProxy.parent=this
    return myProxy;
  }
    
  toggle = () => this.each( _node => 
    _node.style.display = _node.style.display=='none' ? null : 'none'
  )
  
  
  /***************/
  /*** animate ***/
  /***************/
  
  animate = (keyFrames, options) => this.each(_node => _node
    .animate(keyFrames, options))
  

  /***************/
  /**** watch ****/  
  /***************/
  
    //überwacht click und input events des übergebenen Elements
    /*
    <input data-source=message 
      data-filter=inputInt 
      data-func=inputToHex 
      type=text>
    <p>Ergebnis Hex: <b><span data-target=message></span></b></p>
    <button data-action=clickButton>test</button>
    <button data-action=clickButton1>test1</button>
      // bitte beachten, dass die Funktionen vor
      // Aufruf von watch deklariert werden
    "use strict";
    var clickButton = _node => console.log(_node)
    var clickButton1 = _node => console.log($(_node).text())
    var inputToHex = t => t ? new Number(t).toString(16): ''
    var inputInt = t => t.replace(/[^0-9]/g, '')
    $('body').watch()   
    */
  
  watch = (callBack=null) => {
    let handleEvents = evt => handleValues(evt, evt.target)
    let fillValues = _node => {
      if (_node.dataset.filter)
        _node.value = window[_node.dataset.filter](_node.value)
      if (_node.dataset.source)
        $(`[data-target="${_node.dataset.source}"]`)
          .text(_node.dataset.func ? 
          window[_node.dataset.func](_node.value) : 
          _node.value)
    }
    let handleValues = (evt=null, _node) => {
      switch ((evt == null) ? null : evt.type){
        case 'input':
          //check if has  data-source
          if ($(_node).hasData('source')){
            fillValues(_node)
            //console.log(_node)
            if(_node.value==''){
              $(`[data-target="${_node.dataset.source}"]`).n.innerText=''
            }
          }
          if ($(_node).hasData('filter')){
            fillValues(_node)
          }
          
          break;
        case 'click':
          if (_node.dataset.action) 
            window[_node.dataset.action](_node,evt)
          if (_node.dataset.func) 
            window[_node.dataset.func](_node,evt)
          break;
        default:             
          fillValues(_node)
      }
    }
    $(`[data-source]`).each(
      _node=>handleValues(null, _node));
    ['input', 'click'].forEach( evt => 
        $(this.n).on(evt, _evt => handleEvents(_evt)))
    if (callBack) callBack()
    return this
  }
  /*************/
  /**** SVG ****/  
  /*************/
  /* 
    $().sCreate('0,0,100,100').id('mySVG')
    .fill('none').stroke('black')
    .sAppend($().sPath('M 10,10 L 90,10 90,90 10,90 Z').id('myPath'))
    .sAppend($().sCircle(0,0,7).id('myCircle')
      .fill('white')
      .sAppend($().sAnimateMotion()
        .dur('23s')
        //.path('M 10,10 L 90,10 90,90 10,90 Z')
        .repeatCount('indefinite')
        .sAppend(
          $().sMpath().href('#myPath')
        )       
      )
    ).insertAfter($('body h1'))
  */
  sCreate = (viewBox) => {
    let mySVG = document.createElementNS(
      "http://www.w3.org/2000/svg", "svg")
    mySVG.setAttributeNS("http://www.w3.org/2000/xmlns/", 
      "xmlns:xlink", "http://www.w3.org/1999/xlink")
    mySVG.setAttribute('viewBox', viewBox)
    return $(mySVG)
  }
  // fügt angegebenes Element als Child ein
  // gibt aber das Ursprungselement zurück
  // $(mySVG).sAppend($()
  //    .sPath('M 10,10 L 90,10 90,90 10,90 Z')
  //    .id('myPath'))
  sAppend = n => (this.n.appendChild(n.n), this)
  
  svgtext = text => {
    if (text){
      this.each( _node => _node.textContent = text)
      return this;
    } else {
      return this.n.textContent
    }
  }
  // Hilfsfunction  zur Erstellung der SVG Elemente
  // $(this.sC('line')).x1(x1).y1(y1).x2(x2).y2(y2)  
  sC= el => document.createElementNS("http://www.w3.org/2000/svg", el)
  /*** direkte Attribute ***/  
  //$('svg').id('mySVG')
  id = id  => this.setAttr('id', id)
  title = title => this.setAttr('title', title)
  style = style => this.setAttr('style', style)
  type = type => this.setAttr('type', type)
  name = name => this.setAttr('name', name)
  x = x => this.setAttr('x', x)
  x1 = x1 => this.setAttr('x1', x1)
  x2 = x2 => this.setAttr('x2', x2)
  y = y => this.setAttr('y', y)
  y1 = y1 => this.setAttr('y1', y1)
  y2 = y2 => this.setAttr('y2', y2)
  cx = cx => this.setAttr('cx', cx)
  cy = cy => this.setAttr('cy', cy)
  r = r => this.setAttr('r', r)
  rx = rx => this.setAttr('rx', rx)
  ry = ry => this.setAttr('ry', ry)
  width = width => this.setAttr('width', width)
  height = height => this.setAttr('height', height)
  points = points => this.setAttr('points', points)
  d = d => this.setAttr('d', d)
  fill = fill => this.setAttr('fill', fill)
  stroke = stroke => this.setAttr('stroke', stroke)
  strokeWidth = strokeWidth => this.setAttr('stroke-width', strokeWidth)
  strokeLinecap = strokeLinecap => this.setAttr('stroke-linecap', strokeLinecap)
  shortStroke = (stroke, width, caps) => {
    this.setAttr('stroke-width', width)
    this.setAttr('stroke', stroke)
    this.setAttr('stroke-linecap', caps)
    return this
  }
  
  dur = dur => this.setAttr('dur', dur)
  path = path => this.setAttr('path', path)
  repeatCount = repeatCount => this.setAttr('repeatCount', repeatCount)
  href = href => this.setAttr('href', href)
  textAnchor = textAnchor => this.setAttr('text-anchor', textAnchor)
  dominantBaseline = dominantBaseline => this.setAttr('dominant-baseline', dominantBaseline)
  /* some styles */
  color = color => color ? (this.n.style.color=color, this) : this.n.style.color;
  fontWeight = fontWeight => fontWeight ? (this.n.style.fontWeight=fontWeight,this) : this.n.style.fontWeight
  /**** Elemente ****/
  // erstellt neues SVG Element und gibt dieses zurück
  //($(mySVG).sAppend($().sPath('M 10,10 L 90,10 90,90 10,90 Z').id('myPath'))
  sLine = (x1,y1,x2,y2) => $(this.sC('line')).x1(x1).y1(y1).x2(x2).y2(y2)  
  sCircle = (cx,cy,r) => $(this.sC('circle')).cx(cx).cy(cy).r(r)
  sEllipse = (cx,cy,rx, ry) => $(this.sC('ellipse')).cx(cx).cy(cy).rx(rx).ry(ry)
  sRect = (x,y,width,height) => $(this.sC('rect')).x(x).y(y).width(width).height(height)
  sPolyline = points => $(this.sC('polyline')).points(points)
  sPolygon = points => $(this.sC('polygon')).points(points)
  sPath = path => $(this.sC('path')).d(path)
  sBezier = (x,y,x1,y1) => $(this.sC('path'))
    .d(`M${x},${y} C ${(x+x1)/2},${y} ${(x+x1)/2},${y1} ${x1},${y1}`)
  sVBezier = (x,y,x1,y1) => $(this.sC('path'))
    .d(`M${x},${y} C ${x},${(y+y1)/2} ${x1},${(y+y1)/2} ${x1},${y1}`)
  sCurve = (x,y,x1,y1) => $(this.sC('path'))
    .d(`M${(x<x1)?x:x1},${(x<x1)?y:y1} Q${(x+x1)/2},${(x<x1)?y1:y} ${(x1>x)?x1:x},${(x1>x)?y1:y}`)
  sText = (x,y,text) => $(this.sC('text')).x(x).y(y).svgtext(text)
  
  /*** Animationen ***/
  sAnimateMotion = () => $(this.sC('animateMotion'))
  sMpath = () => $(this.sC('mpath'))
  /********* create Icon ************/
  // erstellt ein Icon in der Größe 32 x 32 px
  // übergeben wird der Pfad d ('M 10,10 ....')
  //const iconEnvelope = $().sIcon('M 3 8 L 3 26 L 29 26 L 29 8 Z M 7.3125 10 L 24.6875 10 L 16 15.78125 Z M 5 10.875 L 15.4375 17.84375 L 16 18.1875 L 16.5625 17.84375 L 27 10.875 L 27 24 L 5 24 Z')

  sIcon = (path) => this.sCreate('0,0,32,32')
    .sAppend($().sPath(path)).addClass('icon')
  
  sIconAction = (action) => 
      this.setData('action', action)
        .find('path').setData('action', action).parent()
  /****************************/
  /*** some useful functions***/
  /****************************/
  
  /*** calc average of array **/
  average = (array) => array.reduce((acc, val) => acc + val) / array.length
  /*** handle Json Data ***/
  getJson = (url, callBack, errorBack=null) => {
      function handleErrors(response) {
        if (!response.ok) {
          throw Error(response.statusText);
        }
        return response;
      }
      let myRequest = new Request( url );
      fetch(myRequest)
      .then(handleErrors)
      .then(response => response.json())
      .then(data => {
          callBack(data)
      })
      .catch(error => {
        if (errorBack)
          errorBack(error)
        else
          console.log(error)
      });
  } 
  /*** get Json Row where field === value ***/
  getJsonEqual = (data, field, value) =>
    data[data.findIndex(el => el[field] === value)] 
  /*** get Json Row where field include value ***/
  getJsonInclude = (data, field, value) =>
    data[data.findIndex(el => el[field].includes(value))] 
  /*** calc total from json fields ***/
  getJsonSum = (data, field) => data.map ( el => el[field] )
      .reduce(( sum, val ) => sum + val )
  /*** get Max Value from Json Field ***/
  getJsonMax = (data, field) => Math.max(...data.map ( el => el[field] ))
  /*** get Min Value from Json Field ***/
  getJsonMin = (data, field) => Math.min(...data.map ( el => el[field] ))
  /*** get average from Json Field ***/
  getJsonAverage = (data, field) => this.average(data.map ( el => el[field] ))
 }
  // Style Proxy enable chaining with style Object
  let myStyles = {
    get: (object, property) => {
      return (value) => {
        if (value) {
          object[property] = value;
          return new Proxy(object, myStyles);
        }
        return object[property];
      }
    } 
  }
 return selector = new selection(selector)
};
/******************/
/*** some Tools ***/
/******************/

/* convert csv File to table Element */
/* filename stored in <table data-csv='filename'> */
const csvToTable = async (tableElement) => {
  try {        
      const req = await fetch(tableElement.dataset.csv, {
        method: 'get',
        headers: {
          'content-type': 'text/csv;charset=UTF-8'}
      });
      if (req.status === 200) {
        const csv = await req.text();
        let myTableArray = csv.split('\n')
        let myTable=`<thead><tr><th>
         ${myTableArray[0].replaceAll(';',
        '<th>')}</tr></thead><tbody>`
        myTableArray.shift()
        myTableArray.forEach((aktRow) => {
        myTable+=`<tr><td>${aktRow.replaceAll(
        ';','<td>')}</tr></tbody>`})
        tableElement.
         insertAdjacentHTML('afterBegin', myTable)
      } else {
        console.log(`Error code ${req.status}`);
      }
  } catch (err) {console.log(err)}
};class Dialog {
  constructor ( settings = {} ) {
    this.settings = {...{accept:'OK',cancel:'Abbruch', message:'',template: ''},...settings}
    this.init()
  }
  init() {
    this.dialog = $().create('dialog')
    this.header = $().create('header')
    this.footer = $().create('footer')
    
    this.message = $().create('h2').text('Dialog')
    this.header.sAppend(this.message)
  
    this.template = $().create('div')
    
    this.cancel = $().create('button')
    this.accept = $().create('button')
    
    this.footer
      .sAppend(this.cancel)
      .sAppend(this.accept)
    
    this.dialog
      .sAppend(this.header)
      .sAppend(this.template)
      .sAppend(this.footer)

      .appendEnd($('main'))
    
    
    this.cancel.on('click', () => 
      this.dialog.n.dispatchEvent(new Event ('cancel'))
    
    ) 
    
    this.dialog.on('keydown', evt => {
      if (evt.key == 'Enter'){
        if(evt.target==this.accept.n){
          evt.preventDefault()
          this.accept.n.dispatchEvent(new Event('click'))
        }
      }
    })
  }
  open ( settings = {}, dialogConfirm=true ){
    if (!dialogConfirm){
     return
    }
    
    const dialog = Object.assign({}, this.settings, settings)
    this.accept.text(dialog.accept)
    this.cancel.text(dialog.cancel) 
    this.message.text(dialog.message)
    this.template.n.innerHTML=dialog.template
    
    this.cancel.n.hidden = dialog.cancel === ''
    this.dialog.n.showModal()
    
    if (this.dialog.find('[name]').exist()){
      this.dialog.find('[name]').n.focus()
    } else {
      this.accept.n.focus()
    }
    
    this.template.find('[name]').on('blur', evt => {
      evt.stopPropagation();
      evt.stopImmediatePropagation();
      evt.preventDefault();
      if (this.template.find(':invalid').exist()){
        this.template.find(':invalid').n.focus()
      }
    })
    
  }
  
  getFormData () {
    if (this.template.find(':invalid').exist()){
      this.template.find(':invalid').n.focus()
      return false;
    }
    const fData = {}
    this.template.find('[name]')
    
      .each(el=>{
     
      if (el.type=='checkbox'){
        if (el.checked){
          fData[el.name]='on'
        }
        else{
          fData[el.name]='off'
        }
      }
      else{
        fData[el.name]=el.value
      }
      
    })
    return fData
  }
  

  wait(dialogConfirm=true) {
    
    if (!dialogConfirm){
     return new Promise (resolve => resolve(true))
    }
    
    return new Promise(resolve => {
      this.dialog.on('cancel', () => { 
        //this.template.n.innerHTML=''
        //if (this.template.find('select').nodes.length>0)
          //this.template.find('select').n.style.display='none'
        this.dialog.n.close(true)
      
        resolve(false)
      }, { once: true })
      
      this.accept.on('click', () => {
        let value = this.template.find('input, select, textarea').exist() ? this.getFormData() : true
        this.dialog.n.close()
        resolve(value)
      }, { once: true })
    })
  }

  alert(message) {
    this.open({ cancel: '', message, template: '' })
    return this.wait()
  }
  confirm(message, dialogConfirm=true) {
    this.open({ message, template: '' }, dialogConfirm)
    return this.wait(dialogConfirm)
  }
  prompt(message, value, dataFilter=null) {
    if (dataFilter){
      dataFilter = `data-filter=${dataFilter}`
    } else {
      dataFilter =''
    }
    const template = `<label><input type="text" name="prompt" value="${value}" ${dataFilter} required></label>`
    this.open( { message, template })
    return this.wait()
  }
  
  select(message, options, multiselect=false){
      if (message=='') message = 'Bitte auswählen!'
      let template = `
    <label for="dialogSelect">Auswahl:
    <select id="dialogSelect" name="dialogSelect" required ${multiselect?'multiple':''}>`
    //<option value="">bitte wählen</option>`
    options.forEach(el=>{
      template += `<option value='${el}'>${el}</option>`
    })
    template += `</select></label>`
    this.open ({
      message: message,
      template: template
    })
    return this.wait()
  }
  
  pic(url, direction){
    let template
    if (direction == 'landscape'){
      template =`<div data-picpreview ><img style="max-width:100%" src="${url}" alt="preview"></div>`
    }
    if (direction == 'portrait'){
      template =`<div data-picpreview ><img style="max-height:70vh" src="${url}" alt="preview"></div>`
    }
    this.open({
      message: url.substring(url.lastIndexOf('/')+1),
      template:template,
      cancel:''
    })
    return this.wait()
  }

  editor(area, fileName){
    let template =`<div data-textedit><textarea name=textContent>${area}</textarea></div>`
    this.open({
      message: fileName,
      template:template,
      cancel:'Abbruch',
      accept:'Speichern'
    })
    return this.wait()
  }

}
"use strict"; 
var ajaxserver = './index.php',
    login = true,
    confirmDialog = true
    
const dialog = new Dialog()  
const uploader = createUploadInput()

const database = {
  websites : { fieldDefs : {
    title:            { label: 'Seitenname', type: 'input', filter: 'inputSmall', overview: true},
    menutitle:        { label: 'Menütitel', type: 'input'},
    menuorder:        { label: 'Order', type: 'input', filter: 'inputInt', overview: true},
    visible:          { label: 'sichtbar', type: 'select', options: ['ja', 'nein']},
    content:          { label: 'Seiteninhalt', type: 'textarea'},
    metakeywords:     { label: 'Schlüsselwörter', type: 'input'},
    metadescription:  { label: 'Beschreibung', type: 'input', overview: true},
    metatitle:        { label: 'Metatitel', type: 'input'},
    template:         { label: 'Template', type: 'select', options: ['standard']},
    html:             { label: 'Html', type: 'textarea'},
            
    //template:         { label: 'Template', type: 'select', options: getTemplates() }
  },
    header : 'Seiten',
    icon: '📄',
    buttons: {
      save:           { label: 'Speichern', action: 'save'},
      overview:       { label: 'Übersicht Seiten', action: 'overview'},
      new:            { label: 'Neue Website', action: 'newEntry', overview: true},
      preview:        { label: 'Vorschau', action: 'preview'}
    }
  },
  news : { fieldDefs : {
    date:            { label: 'Datum', type: 'input', inputType: 'datetime-local', overview: true},
    author:          { label: 'Autor', type: 'input'},
    heading:         { label: 'Überschrift', type: 'input'},
    visible:         { label: 'sichtbar', type: 'select', options: ['ja', 'nein']},
    headingtext:     { label: 'Anreisser', type: 'textarea'},
    content:         { label: 'Inhalt', type: 'textarea'},
    tags:            { label: 'Tags', type: 'input'},
    description:     { label: 'Beschreibung', type: 'input', overview: true},
    headingtexthtml: { label: 'Anreisser HTML', type: 'textarea'},
    contenthtml:     { label: 'Inhalt HTML', type: 'textarea'}
  },
    header: 'News',
    icon: '📰',
    buttons: {
      save:           { label: 'Speichern', action: 'save'},
      overview:       { label: 'Übersicht News', action: 'overview'},
      new:            { label: 'Neuer Eintrag', action: 'newEntry', overview:true},
      preview:        { label: 'Vorschau', action: 'preview'}
    }
  },
  textblocks : { fieldDefs : {
    title:           { label: 'Bezeichnung', type: 'input', filter: 'inputSmall', overview: true},
    show:            { label: 'Editor', type: 'select', options: ['ja', 'nein']},
    description:     { label: 'Beschreibung', type: 'input', overview: true},
    content:         { label: 'Inhalt', type: 'textarea'},
    
  },
    header: 'Bausteine',
    icon: '🧱',
    buttons: {
      save:           { label: 'Speichern', action: 'save'},
      overview:       { label: 'Übersicht Bausteine', action: 'overview'},
      new:            { label: 'Neuer Baustein', action: 'newEntry', overview:true}
    }
  },
  templates: { fieldDefs : {
    title:           { label: 'Bezeichnung', type: 'input', filter: 'inputSmall', overview: true},
    description:     { label: 'Beschreibung', type: 'input', overview: true},
    show:            { label: 'Editor', type: 'select', options: ['ja', 'nein']},
    content:         { label: 'Inhalt', type: 'textarea'},
    
  },
    header: 'Templates',
    icon: '📃',
    buttons: {
      save:           { label: 'Speichern', action: 'save'},
      overview:       { label: 'Übersicht Templates', action: 'overview'},
      new:            { label: 'Neues Template', action: 'newEntry', overview:true}
    }
  }
}
const home = {
  logout: {label: 'Logout', action: 'logout', info: 'logout', icon:'🔒' },
  sites: {label: 'Seiten', action: 'show', info: 'websites', screen: 'websitesOverview', icon:'📄' },
  news: {label: 'News', action: 'show', info: 'news', screen: 'newsOverview' , icon:'📰'},
  textblocks: {label: 'Bausteine', action: 'show', info: 'textblocks', screen: 'textblocksOverview' , icon:'🧱'},
  templates: {label: 'Templates', action: 'show', info: 'templates', screen: 'templatesOverview' , icon:'📃'},
  files: {label: 'Dateien', action: 'files', info: 'files' , icon:'📂'},
  settings: {label: 'Adminaufruf', action: 'changeSettings', para: 'changeAdmin',info: 'getadmin' , icon:'🛠'},
  startpage: {label: 'Index Start', action: 'changeSettings', para: 'changeStartPage',info: 'startsite' , icon:'🌍'},
  errorpage: {label: 'Fehlerseite', action: 'changeSettings', para: 'changeErrorPage', info: 'errorsite' , icon:'💣'},
  detailBlog: {label: 'Blog', action: 'changeSettings', para: 'changeBlogPage', info: 'detailblog' , icon:'📰'},
  database: {label: 'Datenbank', action: 'changeSettings', para: 'changeDatabase', info: 'database' , icon:'📇'},
  /*
  markdown: {label: 'Markdown', action: 'changeSettings', para: 'changeMarkdown', info: 'markdown' , icon:'✒'},
  */
  version: {label: 'Version', action: 'version', info: 'version' , icon:'🔖'},
  copyright: {label: 'Copyright', action: 'copyright', info: 'copyright' , icon:'©'},
  license: {label: 'Lizenz', action: 'licence', info: 'license' , icon:'⚖'}
}
const settings = {
  passwort: {label: 'Passwort', para: 'changePass' , info: 'Ändern von Benutzer und Passwort', icon:'🔒'},
  newDatabase: {label: 'neue Datenbank', para: 'newDaba' , info: 'Erstellen einer neuen Datenbank', icon:'📇'},
  exportDatabase: {label: 'sql Dump', para: 'sqlDump' , info: 'Exportieren der Datenbank nach sql', icon:'📥'},
  sqlimport: {label: 'sql Import', para: 'sqlImport' , info: 'Import SQL-Datei in Datenbank', icon:'📤'},
  vacuum: {label: 'Vacuum', para: 'vacuum' , info: 'aktuelle Datenbank komprimieren', icon:'🔨'},
  stemplate: {label: 'Standardtemplate', para: 'stemplate' , info: 'Template für alle Seiten festlegen', icon:'📃'},
  sqledit: {label: 'SQL-Editor', para: 'sqleditor' , info: 'SQL Befehle in aktiver Datenbank ausführen', icon:'📇'},
  createHtaccess: {label: 'htaccess', para: 'createHtaccess' , info: 'erstellt eine .htaccess Datei im Hauptverzeichnis', icon:'🔃'},
  /*
  changemarkdown: {label: 'markdown', para: 'changeMarkdown' , info: 'Markdown Parser ändern', icon:'✒'},
  */
  update: {label: 'update', para: 'update' , info: 'aktuelle Version installieren', icon:'⟳'}
  /*
  startPage: {label: 'Startseite', para: 'changeStartPage' , info: 'Festlegung der Startseite zur Internetpräsenz'},
  errorPage: {label: 'Fehlerseite', para: 'changeErrorPage' , info: 'Festlegung der Fehlerseite zur Internetpräsenz'},
  blogPage: {label: 'Blog', para: 'changeBlogPage' , info: 'Festlegung der Blog Detailansicht'},
  adminCall: {label: 'Admin', para: 'changeAdmin' , info: 'Ändern des Parameters zum Aufruf der Verwaltungsoberfläche'}
  */
}
const niceJson = e => JSON.stringify(e, null, 2)
function changeDir (el){
  get({action:'changeDir', directory: el.innerText}, ()=> readFiles() )
}
function changeMarkdown(el){
  dialog.select('Bitte Markdown Parser auswählen:', ['intern', 'Parsedown'])
  .then ( res => {
    if(res){
      get(
        {action:'changeSettings', setting:el.dataset.para, newVal: res.dialogSelect},
        data => {
          dialog.alert(data.message).then(()=>getInfo())
        }
      )
    }
  })  
}
function changeSettings (el){
  // console.log(el.dataset.para)
  switch (el.dataset.para) {     
    case 'changeStartPage':
      get({action:'getLinks'}, data => {
          dialog.select('bitte Startseite auswählen', data.rows.map(x=>x.title))
         .then (res => {
            if (res) {
              get ({action:'changeSettings', setting:el.dataset.para, newVal: res.dialogSelect},
                e => {
                  //console.log(niceJson(e))
                dialog.alert('neue Startseite: '+e.message).then(()=>getInfo())
                //getInfo();
              })
            }
          })})
      break;
    case 'changeErrorPage':
      get({action:'getLinks'}, data => {
          dialog.select('bitte Fehlerseite auswählen', data.rows.map(x=>x.title))
         .then (res => {
            if (res){
              get ({action:'changeSettings', setting:el.dataset.para, newVal: res.dialogSelect},
                e => {
                  dialog.alert('neue Fehlerseite: '+e.message).then(()=>getInfo())
                  //getInfo()     
                })}})})
      break;
    case 'changePass':
      dialog.open({
        accept: 'Ändern',
        message: 'Bitte alle Daten eingeben!',
        template: `
            <form>
              <label>Benutzername<input type="text" name="username" autocomplete required></label>
              <label>Passwort<input type="password" name="password" autocomplete required></label>
              <label>Neuer Benutzername<input type="text" name="newusername" autocomplete required></label>
              <label>Neues Passwort<input type="text" name="newpassword" autocomplete required></label>
          </form>`
      })
      dialog.wait().then((res) => { 
        if(res){
          get({
            action: 'changeSettings', 
            setting:el.dataset.para,
            username: res.username,
            newusername: res.newusername,
            password: res.password,
            newpassword: res.newpassword,
            
          }, resp => {
            dialog.alert(resp.message).then(()=>checkLogin())
            //checkLogin()         
          })
          
          
        }
      })
      break;
      //
    case 'changeAdmin':
      dialog.prompt('bitte neuen Parameter eingeben!',$('[data-info="getadmin"] b').text(), 'inputabc')
        .then(res => {
          if(res){
            get({action:'changeSettings', setting: el.dataset.para, newVal: res.prompt}, 
              data => $('[data-info="getadmin"] b').text(data.message))
            
          }
      })
      break;
      
    case 'changeBlogPage':
      //console.log('changeBlogPage')
      get({action:'getLinks'}, data => {
          dialog.select('bitte Detailseite des Blogs auswählen', data.rows.map(x=>x.title))
         .then (res => {
            if (res){
              get ({action:'changeSettings', setting:el.dataset.para, newVal: res.dialogSelect},
                e => {
                  dialog.alert('Blogseite: '+e.message).then(()=>getInfo())
                  getInfo()
                })
            }
          })
      })
      break;
      
    case 'changeDatabase':
      //console.log('ChangeDatabase')
      get({action: 'getDabas'}, (data) => {
        //console.log(niceJson(data))
        dialog.select('bitte zu aktivierende Datenbank auswählen!', data.rows)
        .then(res => {
          //console.log(res)
          if(res){
             get ({action:'changeSettings', setting:el.dataset.para, newVal: res.dialogSelect},
                e => {
                  dialog.alert('akt. Datenbank: '+e.message).then(()=>getInfo())
                  //getInfo()
             }) 
          }
        })
      })
      break;
    
    case 'newDaba':
      dialog.prompt('Bitte zu aktivierende Datenbank eingeben', '', 'inputDirNames')
        .then( res => {
          if(res){
            //console.log(res.prompt)    
            get({action:'changeSettings', setting:el.dataset.para, newVal: res.prompt}, data =>{
              dialog.alert('neue Datenbank: '+data.message).then(()=>getInfo())
              //getInfo()
              readFiles()
            })
          }
        })
      break;
    
    case 'sqlDump':
        if ($('#filemanagerPath').text()!=='/'){
            dialog.alert('Bitte wechseln Sie mit dem Dateimanager in´s Hautpverzeichnis')
        return
      }
      //console.log('sqlDump')
      get({action:'getDabas'}, data => {
        //console.log(niceJson(data))
        dialog.select('bitte zu exportierende Datenbank auswählen!', data.rows)
        .then(res => {
          if(res){
            let database = res.dialogSelect
            //console.log(database)
            get({action: 'getTables', database: database}, data => {
              //console.log(niceJson(data))
              let tables = data.rows.map(x=>x.name)
              //console.log(tables)
              let template = '<form>'
              tables.forEach(val=>{
                template += `<label>${val}<input type="checkbox" name="${val}" checked></label>`
              })
              template+='</form>'
              dialog.open({
                message: 'Bitte Tabelle(n) auswählen!',
                template: template
              })
              dialog.wait()
              .then (data => {
                //console.log(data)
                if(data){
                  get({action:'sqlDump', database: database, tables: Object.keys(data).filter(key=>data[key]=='on')}, data=>{
                    //console.log(niceJson(data))
                    readFiles()
                })
              }
              })
            })  
          }
        })
      })
      
    break; 
    case 'sqlImport':
      //console.log('sqlImport')
       get({action:'getSQLFiles'}, data => {
        //console.log(niceJson(data)) 
        if(data.status == 'OK'){
           dialog.select('bitte SQL-Datei auswählen auswählen!', data.rows)
          .then ( res => {
            if (res) {
              let SQLFile = res.dialogSelect
              get({action: 'getDabas', database: database}, data => {
                //console.log(data)
                if (data.status=='OK'){
                  dialog.select('bitte Datenbank auswählen!', data.rows)
                  .then(res => {
                    if(res){
                      let database = res.dialogSelect
                      get({ action: 'sqlImport', sqlFile: SQLFile, database: database},
                        data =>{
                          //console.log(niceJson(data))
                          if (data.status == 'OK'){
                            dialog.alert(data.message)
                          }
                      })
                    }
                  })
                }
              })
            }   
          })
        }
       })
    break;  
    case 'vacuum':
      //console.log('vacuum')
      get({ action: 'vacuum'},
        data => {
          if (data.status == 'OK'){
            readFiles()
            dialog.alert(data.message)
          }
      })
      break;
    case 'stemplate':
      get({action: 'getTemplates'},data=>{
        dialog.select('Template als Standardtemplate setzen!', data.rows.map(x=>x.title))
          .then( 
            res => {
              if(res){
                get ({action:'changeSettings', setting:el.dataset.para, newVal: res.dialogSelect},
                data => {
                  console.log(niceJson(data))
                    if (data.status == 'OK'){
                      dialog.alert(`${data.affected} Datensätze geändert!`)
                    }
                }) 
              }
            }   
          )
      
      })
      break;
    
    case 'sqleditor':
      sqlEdit()
      break;  
      
    case 'createHtaccess':
      get(
        {action: 'createHtaccess'},
        data => {
          if (data.status == 'OK'){
            dialog.alert(data.message).then(()=>readFiles())
          }
        }
      )
      break;
    
    case 'changeMarkdown':
      changeMarkdown(el)
      break;
      
    case 'update':
    
      get({action:'update'},
          data => {
            dialog.alert(data.message)
       
          }
        )
      break;
      
    default:
    //  
  }

}
function checkLogin () {
  get( {action:'checklogin'}, data =>{
    if(!data.login){
      dialog.open({
        accept: 'Login',
        message: 'Bitte entsprechende Daten eingeben!',
        template: `
          <form>
          <label>Benutzername<input type="text" name="username" value="" autocomplete required></label>
          <label>Passwort<input type="password" name="password" value="" autocomplete required></label>
          </form>`
      })
      dialog.wait().then((res) => {  
        if(res){
          get ( {action:'login', user:res.username, pass:res.password},
            e => {
            getInfo()
            readFiles()
            getTemplates()
                 },    
            e => dialog.alert(e.message).then(()=>checkLogin())        
          )          
        } else {
          checkLogin()
         
        }
      })
    } else {
      getInfo()
      readFiles()
      getTemplates()
    }
  })  
}
function createDir () {
  dialog.prompt('Bitte Verzeichnisname eingeben', '', 'inputDirNames')
    .then(res=>{
      if(res){    
        let newDir = res.prompt;
        get({action:'createDir', dirName: res.prompt}, 
          data => {
          readFiles()
        })
  }
  })
}
function createFile(){
  if ($('#filemanagerPath').text()=='/'){
    dialog.alert('Im Rootverzeichnis nicht erlaubt!')
    return
  }

  dialog.prompt('Bitte Dateinamen eingeben', '', 'inputFileNames')
  .then ( res => {
    if(res){
      console.log(res.prompt);
      get(
        {action: 'createFile', filename: res.prompt},
        data => {
          console.log(data)
          dialog.alert(data.message).then(()=>readFiles())
        }
      )
    }
  })
  
}
function createFilemanager(){
  let filemanager = $().create('div')
    .setData('screen', 'filemanagerScreen')
    .addClass('hidden')
    //.setAttr('data-active')
    .append('div').addClass('title-search')
    .append('h1')
      .text('Dateien')
      .parent()
    .append('input').setData('search','').setAttr('placeholder', '🔍')
    .parent()
    .parent()
    .append('div')
      .append('p')
        .text('Aktuelles Verzeichnis: ')
        .append('span')
          .setAttr('id', 'filemanagerPath')
          .text('/')
          .parent()
        .parent()
    .append('table')
      .setAttr('id', 'filemanager')
      .append('thead')
      .append('tr')
      .sAppend($().create('th').text('Name'))
      .sAppend($().create('th').text('Typ'))
      .sAppend($().create('th').text('Datum'))
      .sAppend($().create('th').text('Größe'))
      .sAppend($().create('th').text(' '))
      .sAppend($().create('th').text('✓').setData('action', 'setConfirm'))
      .parent()
      .parent()
      .sAppend($().create('tbody'))
    .parent()
    .parent()
    .sAppend($().create('button').setData('action', 'createFile').text('Neue Datei'))
    .sAppend($().create('button').setData('action', 'createDir').text('Neues Verzeichnis'))
    .sAppend($().create('button').setData('action', 'upload').text('Hochladen'))
    //.sAppend($().create('button').setData('action', 'getAllDirectories').text('Verzeichnisliste'))
  $('main').sAppend(filemanager)
}
function createHomeScreen () {
  let homeScreen = $().create('div').setData('screen', 'home').setAttr('data-active')
  
  homeScreen.sAppend($().create('h1').text('Home').addClass('max'))
  
  Object.keys(home).forEach( function ( key ) {
    homeScreen.sAppend(
      $().create('div').addClass('cards').setData('action',home[key]['action']).setData('para', home[key]['para']??'').setData('screen', home[key]['screen']??'home')
      .sAppend($().create('h3').text(home[key]['icon']?home[key]['icon']:'x')
               .setData('action',home[key]['action']).setData('para', home[key]['para']??'').setData('screen', home[key]['screen']??'home')
              )
      .sAppend($().create('p').text(home[key]['label'])
               .setData('action',home[key]['action']).setData('screen', home[key]['screen']??'home').setData('para', home[key]['para']??'')
              )
      .sAppend($().create('p').setData('info',home[key]['info'] )
          .setData('action',home[key]['action']).setData('screen', home[key]['screen']??'home').setData('para', home[key]['para']??'')
      )
    )
  })
  $('main').sAppend(homeScreen)
}
function createPreviewDialog(){
  let myDialog = $().create('dialog').setAttr('id', 'previewCMS')
  myDialog.append('div').append('h1').text('So sieht Ihre Website aus:')
  myDialog.append('div').append('iframe')
  myDialog.append('div').append('button').text('Vorschau schließen').setAttr('id', 'closePreview')
  myDialog.appendEnd($('body'))
}
function createSettingsScreen(){
  let settingsScreen = $().create('div').setData('screen', 'settings').addClass('hidden')
  settingsScreen.sAppend($().create('h1').text('System').addClass('max'))
  Object.keys(settings).forEach( function ( key ) {
    settingsScreen.sAppend(
      $().create('div').addClass('cards').setData('action','changeSettings').setData('para', settings[key]['para'])
      .sAppend($().create('h3').text(settings[key]['icon']?settings[key]['icon']:'x').setData('action','changeSettings').setData('para', settings[key]['para']))
      .sAppend($().create('p')
        .text(settings[key]['label'])
        .setData('action','changeSettings').setData('para', settings[key]['para']))
      .sAppend($().create('p').text(settings[key]['info'] ).setData('action','changeSettings').setData('para', settings[key]['para']))
    )
  })
  $('main').sAppend(settingsScreen)
}
function createTableViews () {
  let screens = new Array();
  Object.keys(database).forEach( function ( key ) {
    // Detailansichten
    screens[key]=$().create( 'div' )
      .setData( 'screen' , key )
      .addClass('hidden')      
      //$(screens[key]).append('h1').text(`${database[key]['header']} Detail`)
      $(screens[key]).append('div').addClass('title-search').append('h1').text(`${database[key]['header']}`)
      
    
      $().create('li')
        //.text(key)
        .text(database[key]['icon'])
        .setData('action', 'show')
        //.setData('screen', key)
        .setData('screen', `${key}Overview`)
        .setData('title', database[key]['header'])
        //.appendEnd($('nav ul'))
        .insertBefore($('nav ul li[data-action="logout"]'))
        
        $(screens[key]).append('input')
          .setAttr('type', 'hidden')
          .setAttr('name', 'rowid')
          .setAttr('value', '')
    
    
      Object.keys(database[key]['fieldDefs']).forEach ( function ( col ) { 
        $(screens[key]).append('label')
          .text(database[key]['fieldDefs'][col]['label'])
          .setAttr('for', `${key}-${col}`)
          .append(database[key]['fieldDefs'][col]['type'])
          .setAttr('id', `${key}-${col}`)
          .setAttr('name', col)
          .setAttr('required')
          if (database[key]['fieldDefs'][col]['type']=='select'){
            $().create('option')
              .text('bitte wählen')
              .setAttr('value', '')
              .appendEnd($(screens[key]).find(`#${key}-${col}`))
            database[key]['fieldDefs'][col]['options'].forEach ( option => 
                $().create('option')
                .text(option)
                .setAttr('value', option)
                .appendEnd($(screens[key]).find(`#${key}-${col}`)))
          }
          if (database[key]['fieldDefs'][col]['filter']){
            $(screens[key]).find(`#${key}-${col}`).setData('filter', 
              database[key]['fieldDefs'][col]['filter'])
          }
          if (database[key]['fieldDefs'][col]['inputType']){
            $(screens[key]).find(`#${key}-${col}`).setAttr('type', database[key]['fieldDefs'][col]['inputType'])
          }
      })
      
      if (database[key]['buttons']){
           Object.keys(database[key]['buttons']).forEach( button => {
             //console.log(button)
             $().create('button')
              .text(database[key]['buttons'][button]['label'])
              .setData('action', database[key]['buttons'][button]['action'])
              .appendEnd($(screens[key]))
             
           })
      }
    $(screens[key]).appendEnd($('main'))
    
    
    //nun die Tabellenübersicht
    screens[`${key}Overview`]=$().create( 'div' )
      .setData('screen', `${key}Overview`)
      .addClass('hidden')
    $(screens[`${key}Overview`])
      .append('div').addClass('title-search')
      .append('h1').text(`${database[key]['header']}`).addClass('half')
      .parent()
      .append('input').setData('search','').setAttr('placeholder', '🔍').addClass('half')
      .parent()
      .parent()
      .append('table')
      .setData('table', key)
      .append('thead')
      .append('tr')
      .parent('table')      
      .append('tbody')
      
    Object.keys(database[key]['fieldDefs']).forEach ( function ( col ) {
      if (database[key]['fieldDefs'][col]['overview']){
        //console.log(database[key]['fieldDefs'][col]['label'])    
        $(screens[`${key}Overview`])
          .find('table thead tr')
          .append('th')
          .text(database[key]['fieldDefs'][col]['label'])
      }
    })
    $(screens[`${key}Overview`]).find('table thead tr')
          .append('th').text('✓').setData('action', 'setConfirm')
    if (database[key]['buttons']){
       Object.keys(database[key]['buttons']).forEach( button => {
         if (database[key]['buttons'][button]['overview']){
           $().create('button')
           .text(database[key]['buttons'][button]['label'])
           .setData('action', database[key]['buttons'][button]['action'])
           .appendEnd($(screens[`${key}Overview`]))
         }
       })
    }
    $(screens[`${key}Overview`]).appendEnd($('main'))
  })
}
function createTextHelpers () {
  var myTextHelpers = {
    max : '⬍',
    bold : 'b',
    italic: 'i',
    linethrough: 'D',
    code : 'C',
    newline : '⏎',
    image: '📷',
    link: '🔗',
    brick: '🧱',
    excelpaste: '▦',
    excelpastejson: 'Ⓙ'
    //preview : '👀'
  }
  let thCont = $().create('div').setData('thowner', null).addClass('thhidden')
  $('main').sAppend($(thCont))
  for (let key in myTextHelpers) {
    $(thCont).append('p')
      .html(myTextHelpers[key])
      .setData('action', 'texthelper')
      .setData('para', key)
  }
  $('textarea').on('focus', e => {
  $('[data-thowner]').setData('thowner', e.currentTarget.id)
  .insertBefore($(e.currentTarget)).removeClass('thhidden');
  })
}
function createUploadInput (){
  let uploadFile = $().create('input').n
  uploadFile.type = 'file'
  uploadFile.multiple = true
  $(uploadFile).on('change', function (e) {
    e.preventDefault()
    let sum = [...this.files].reduce((a,o)=>a+o.size,0)
    if (sum > 3000000){
      dialog.alert('Die maximale Upload Größe (3M) wurde überschritten!')
      this.value=''
      return
    }
    let max = Math.max(...[...this.files].map(o => o.size))
    if (max > 1500000){
      dialog.alert('Die maximale Dateigröße (1.5M) wurde überschritten!')
      this.value=''
      return
    }
    let myForm = new FormData()
    myForm.append('action', 'upload')
    for (let i = 0; i < this.files.length; i++){
      myForm.append('files[]', this.files[i])
    }
    this.value=''
    fetch(ajaxserver, { method: 'POST',body: myForm})
      .then (r => r.json())
      .then (data=>{
        if (data.status === "OK"){
            
            dialog.alert(data.message)
            readFiles()
        }
        if (data.status === "ERROR"){
            dialog.alert(data.message)
        } 
      })
      .catch(error => console.log(error))
  }) 
  return uploadFile
}
function copyright(){
  dialog.alert(`
Alle Rechte hat:
Frank Wisniewski
Lohmühlenstraße 2
53518 Adenau
`)
}
function detail(el){
  function fillDetail(data){
    for (let key in data.rows[0]){
        $(`div[data-screen="${data.table}"] [name="${key}"]`).n.value='';
        $(`div[data-screen="${data.table}"] [name="${key}"]`).n.value=data.rows[0][key]
    }
  }
  get({action: 'detail', rowid: $(el).parent('tr').getData('rowid'), 
       table: $(el).parent('table').getData('table')},
      data=>fillDetail(data))
  $("main [data-active]").toggleClass('hidden').removeAttr('data-active')
  $(`main>div[data-screen=${$(el).parent('table').getData('table')}]`).toggleClass('hidden').setAttr('data-active')
}
function deleteFile (el){
  dialog.confirm('Möchten Sie wirklich löschen?', confirmDialog).then ( res => {
    if(res){
      get({action:'deleteFile', filename: $(el).parent('tr').find('td:first-child').text()},
        (data) => {
          readFiles()
        }  
      )
    }
  })
}
function deleteTableRow(el){
  let myForm = new FormData()
  myForm.append('action', 'deleteTableRow')
  myForm.append('table', $(el).parent('table').getData('table'))
  myForm.append('rowid', $(el).parent('tr').getData('rowid'))
  if (confirmDialog){
  dialog.confirm('soll der Datensatz wirklich gelöscht werden?')
    .then( (res) => {
      if (res){
        get(Object.fromEntries(myForm), () => {
          $(`[data-action="show"][data-screen="${$(el)
            .parent('table').getData('table')}Overview"]`).n.click()
        })
        if($(el).parent('div').getData('screen')=='templatesOverview'){
          getTemplates()
        }
      }
    })
  } else {
    get(Object.fromEntries(myForm), () => {
          $(`[data-action="show"][data-screen="${$(el)
            .parent('table').getData('table')}Overview"]`).n.click()
        })
  }
}
function download(el){
  $().create('a').setAttr('href', $('#filemanagerPath')
    .text()+$(el).text()).setAttr('download','').n.click()
}
function editStyleSheet (el){
  let fileName = '.'+$('#filemanagerPath').text()+el.textContent
    fetch(fileName)
      .then(response => {
       if (!response.ok) {
         dialog.alert('Network response was not OK');
        throw new Error('Network response was not OK');
      } else {
      return response.text()
      }
    }) 
      .then(textString => {
      dialog.editor(textString, fileName)
        .then( res => {
          if(res){
            get(
              {action: 'saveStylesheet', filename: el.textContent, textcontent: res.textContent},
              data => {
                dialog.alert(data.message);
              }
            ) 
          }
        })
      })
}
function excelPaste(area, before, after){
  navigator.clipboard.readText().then( (clipText) => {
    clipText.trim();  
    let rows = clipText.split(/\r?\n/g)
    rows = rows.filter(el => el != '')
    let content = []
    rows.forEach((row, index)=>
      content[index] = [...row.split(/\t/)]
    )
    if (content.length===0) {
      markdown=''
    }
    else{
    let cols = content[0].length
    let widthCols = []
    for (let i=0; i<cols; i++){
      widthCols[i] = Math.max(...(content.map( (el) => el[i].length)));
    }
    content[0].forEach((col, index)=>
      content[0][index] = col.padEnd(widthCols[index])                  
    )
    let markdown = '| ' + content[0].join(' | ') + " |\n|-"
    for (let i=0; i<cols; i++){
      markdown = markdown + ('-'.repeat(widthCols[i])) + '-|-'
    }
    markdown=markdown.slice(0,-1)+"\n";

    for (let i=1; i<content.length; i++){
      content[i].forEach((col, index)=>
        content[i][index] = col.padEnd(widthCols[index])                  
      )
      markdown = markdown + '| ' + content[i].join(' | ') + " |\n"
    }
      area.value = before+markdown+after
      area.selectionEnd=before.length+markdown.length
      area.focus()
      
    }
  })
}  
function excelPasteJson(area){
  navigator.clipboard.readText()
    .then( (clipText) => {
      if (clipText=='') {
        return
      }
      clipText.trim();  
      let rows = clipText.split(/\r?\n/g)
      if (rows.length < 2){
        return
      }
      rows = rows.filter(el => el != '')
      let content = []
      rows.forEach((row, index)=>
        content[index] = [...row.split(/\t/)]
      )
      let JsonArray = [];
      for (let i = 1; i < rows.length; i++){
        let tempArray = {}
        content[i].forEach((e,index)=>{       
          tempArray[content[0][index]]=e
        })
        JsonArray.push(tempArray)
      }
      area.value = JSON.stringify(JsonArray,null,2)
  })
}
function files(){
  $('[data-action="show"][data-screen="filemanagerScreen"]').n.click()
}
function get(formArray, isok = null, iserror = null ){
  let myForm = new FormData()
  for ( var key in formArray){
    myForm.append(key, formArray[key]);
  }
  fetch(ajaxserver, { method: 'POST',body: myForm})
  .then (r => r.json())
  .then (data=>{
    if (data.status === "OK"){
      if (isok){
        //console.log(data)
        isok(data) 
      }else{
        //console.log(data)
        dialog.alert(data.message)
      }
    }
    if (data.status === "ERROR"){
      if (iserror){
        iserror(data)
      } else {
        //console.log(data)
        dialog.alert(data.message)
      }
    } 
  })
  .catch(error => console.log(error))
}
function getAllDirectories (){
  get({action:'getAllDirectories'}, 
          data => {
          dialog.select('Zielverzeichnis auswählen!', data.dirs)
            .then(res=>console.log(res.dialogSelect))
        })
}
function getInfo(){
  get({action: 'getInfo', info: 'getall'}, data => {
    for (let key in data)
      $(`[data-info="${key}"]`).html(data[key])
  })
}
function getTemplates () {
  get({action: 'getTemplates'}, data => {
      
      $('#websites-template option').remove()
      $('#websites-template').sAppend($().create('option').text('bitte wählen').setAttr('value',''))
      data.rows.map(x=>x.title).forEach  (el => {
        $('#websites-template').sAppend($().create('option').text(el).setData('value', el))
      })
  }, data => {
    dialog.alert('Es muss mindestens ein Template sichtbar sein!')
  })
}
function handleFileClick (el) {
  let fileType = $(el).parent('tr').find('td[data-filetype]').text()
  if (fileType=='Bild'){
    let picUrl = '.'+$('#filemanagerPath').text()+$(el).text()
    const img = new Image();
    img.onload = function() {
      let direction = 'portrait'
      if (this.width >= this.height){
        direction = 'landscape'
      } 
      dialog.pic('.'+$('#filemanagerPath').text()+$(el).text(), direction)
      
      //alert(this.width + 'x' + this.height);
    }
    img.src = picUrl;
    
    
    //dialog.pic('.'+$('#filemanagerPath').text()+$(el).text())
  }
  if (fileType=='Datenbank') {
    download(el)
  }
  if (fileType=='SQL Dump') {
    download(el)
  }
  
  if (fileType=='Stylesheet'){
    editStyleSheet(el)
  }
  if (fileType=='Text'){
    editStyleSheet(el)
  }
  
  if (fileType=='Javascript'){
    editStyleSheet(el)
  }
  if (fileType=='htaccess'){
    editStyleSheet(el)
  }  
}
function init(){
  createHomeScreen()
  createTableViews()
  createFilemanager()
  createSettingsScreen()
  createTextHelpers()
  createPreviewDialog()
  initSearch()
  $('#closePreview').on('click', () => {
    $('#previewCMS').n.close()
    $('#previewCMS iframe').n.src=''
  })
  checkLogin()
  
  $('body').watch()
  $('body').on(
    'checkForSize',
    () => myResize()
  )
  window.addEventListener("resize", myDebounce( myResize, 400 ));
  
  myResize();
  //show tooltios only on desktop
  if (!('ontouchstart' in document.documentElement)){
    $('[data-title]').
    on(
      'mouseover',
      (evt) => {
        let el = evt.target
        let bodyRight = $('body').n.getBoundingClientRect().right
        let tip = $().create('div').addClass('tooltip').
        style(`
            font-weight: bold;
            position: absolute;  
            padding: 0.75em;
            top: ${el.getBoundingClientRect().bottom+15}px;
            background:#fafafa;
            right: ${bodyRight-el.getBoundingClientRect().right}px;
            border-radius:5px;
            box-shadow: rgba(150,150,150, 0.5) 1px 2px 6px ;
            `)
        tip.sAppend(
          $().create('p').
            text(el.dataset.title)
        ).
        appendEnd($('body'))
      }
    )
      $('[data-title]').on('mouseout',() => {$('.tooltip').remove()})
  }
  // only for firefox label:has(textrea) error
  $('main>div label textarea').each(el=>{
    el.parentElement.style.width='100%';
  })
  
}
function inputDirNames (t) {
  return t.replace(/[^a-z-]/g, '') 
}
function inputFileNames (t) {
  return t.replace(/[^a-z-\.]/g, '') 
}
function inputInt (t) {
  return t.replace(/[^0-9]/g, '')
}
function inputSmall (t) {
  return t.replace(/[^a-zäöüß-]/g, '') 
}
function inputabc (t) {
  return t.replace(/[^a-z]/g, '')
}
function isValidRegex(regExp){
  try {
    new RegExp(regExp);
  } 
  catch(e) {
    return false
  }
  return true
}
function licence(){
  dialog.alert('Die Lizenz wurde noch nicht festgelegt!')
}
function logout(){
  get({action:'logout'}, 
    e => dialog.alert(e.message).then(()=>{
      $('[data-info="logout"]').html(`Status: <b>ausgeloggt</b>`)
      location.replace("./index.php")
      //checkLogin()
    }),
    e => dialog.alert(e.message).then(()=>checkLogin()))
    //e => dialog.alert(e.message).then(()=>location.replace("./index.php")))
}
function myDebounce(func){
  var timer;
  return function(event){
    if(timer) clearTimeout(timer);
    timer = setTimeout(func,100,event);
  };
}
function myResize () {
  /* fix vor 100vh Problem */
  $('body').n.style.minHeight = window.innerHeight - 1 + 'px';
  /* end Fix */
  let activeScreen = $('[data-active]')
  let screenName = activeScreen.getData('screen')
  let windowHeight = parseInt(window.innerHeight)
  if ( screenName == 'filemanagerScreen' || screenName.includes('Overview')){
    activeScreen.find('tbody').n.style.height='250px'
    let lastButton =  parseInt(activeScreen.find('button').last().n.getBoundingClientRect().bottom)
    let lastButtonHeight =  parseInt(activeScreen.find('button').last().n.getBoundingClientRect().height)
    let footerTop = parseInt($('body>footer').n.getBoundingClientRect().top)
    let footerBottom = parseInt($('body>footer').n.getBoundingClientRect().bottom)
    if( (footerTop - lastButton) > 10 ){
      let aktBodyHeight = activeScreen.find('tbody').n.getBoundingClientRect().height
      let newHeight = footerTop  - lastButton + aktBodyHeight - lastButtonHeight
      activeScreen.find('tbody').n.style.height=`${newHeight}px`
    }
    
    
    
    
    /*
    if (footerBottom==windowHeight){
      if( lastButton <= footerTop ){
        let aktBodyHeight = activeScreen.find('tbody').n.getBoundingClientRect().height
        let newHeight = footerTop  - lastButton + aktBodyHeight - lastButtonHeight
        activeScreen.find('tbody').n.style.height=`${newHeight}px`
        console.log('hier auch')
      } 
    
    }
    */
  }  
}
function newEntry (el) {
  let table = null
  if($(el).parent('div').find('table').exist()){
    table = $(el).parent('div').find('table').getData('table')
  } else {
    table = $(el).parent('div').getData('screen')
  }
  $("main [data-active]").toggleClass('hidden').removeAttr('data-active')
  $(`main>div[data-screen=${table}]`).toggleClass('hidden').setAttr('data-active')
  $(`main>div[data-screen=${table}]`).find('[name]').each( el => el.value='')
}
function overview (el) {
  $(`[data-action="show"][data-screen="${$(el).parent('div').getData('screen')}Overview"]`).n.click()
}
function preview (el) {
  let table = $(el).parent('div').getData('screen')
  let link='';
  window.scrollTo({ top: 0, behavior: 'smooth' });
  if (table=='news'){
    link = $(el).parent('div').find('#news-date').n.value;
    //console.log (link)
    
    let site=  $('[data-info="detailblog"] b').text()
    //console.log(site)
    
    if (site == 'nicht definiert'){
      dialog.alert("Sie haben noch keine Seite für die Blogvorschau definiert!")
      .then( () => $('[data-para="changeBlogPage"]').n.click())
    } else {
       previewCmsOpen(`index.php?site=${site}&news=${link}`)
    }
  }
  if (table=='websites'){
    link = $(el).parent('div').find('#websites-title').n.value;
    previewCmsOpen(`index.php?site=${link}`)
  }
}
function previewCmsOpen(myUrl){
  $('#previewCMS iframe').n.src=myUrl
  $('#previewCMS').n.showModal()
}
function readFiles(){
  get({action: 'readDirectory'}, data => {
    filemanagerPath.innerText=data.aktDir.replaceAll('\\','/')
    filemanagerPath.innerText=filemanagerPath.innerText.replaceAll('//','/')
    $('#filemanager tbody').html('')
    data.files.forEach(el => {
      $('#filemanager tbody')
        .sAppend(
          $().create('tr')
            .sAppend($().create('td').text(el.filename)
              .setData('action', `${el.filetype=='Verzeichnis'?'changeDir':'handleFileClick'}`))
            .sAppend($().create('td').text(el.filetype)
              .setData('filetype', 
              ((el.filetype == 'Verzeichnis') ? 'DIR' : 'FILE')))
            .sAppend($().create('td').text(el.filedate))
            .sAppend($().create('td').text(el.filesize))
            
            .sAppend($().create('td')
              .text(`${el.filename=='..'?'':'✎'}`)
              .setData('action', `${el.filename=='..'?'changeDir':'renameFile'}`))
            .sAppend($().create('td')
              .text(`${el.filename=='..'?'':'🗑'}`)
              .setData('action', `${el.filename=='..'?'changeDir':'deleteFile'}`))
      )
    })
  }) 
}
function renameFile (el){
  let fileName = $(el).parent('tr').find('td:first-child').text()
  dialog.prompt('Bitte neuen Dateinamen eingeben', fileName, 'inputFileNames')
    .then(res => {
      if(res){
        get({action:'renameFile', filename: fileName, newfilename: res.prompt}, 
        data => {
         //console.log(data)
        readFiles()
      })
    }
  })
}
function save (el) {
      let tempakt = $(el).parent('div').getData('screen')
      if (tempakt === 'websites'){
        $('#websites-html').n.value= fhwMD($('#websites-content').n.value, {autoid:true} )
      }
      if (tempakt === 'news'){
        $('#news-headingtexthtml').n.value= fhwMD($('#news-headingtext').n.value, {autoid:true} )
        $('#news-contenthtml').n.value= fhwMD($('#news-content').n.value, {autoid:true} )
        
      }
  
   if ($(el).parent('div').find(':invalid').exist()){
     dialog.alert('Bitte die erforderlichen Felder ausfüllen!').then(()=>
         $(el).parent('div').find(':invalid').n.focus())
     $(el).parent('div').find(':invalid').n.focus()
    } else {
      let myForm = new FormData()
      myForm.append('action', 'save')
      // changed new
      
      
      
      myForm.append('table', $(el).parent('div').getData('screen') )
        $(el).parent('div').find('[name]').each(el => {
          myForm.append(el.name, el.value)
        })
      get(Object.fromEntries(myForm), (data)=>{
        if($(el).parent('div').getData('screen')=='templates'){
          dialog.alert('Datensatz gespeichert!')
          .then(res=>getTemplates())
        } else {
          dialog.alert('Datensatz gespeichert!')
        }
        if (data.lastins!=='0'){
          $(el).parent('div').find('[name="rowid"]').n.value=data.lastins
        }        
        //dialog.alert('Datensatz gespeichert!')
      })
    }
}
function initSearch(){
  $('[data-search]').on('keyup', (evt) => {
    let aktEl = evt.target
    let aktTableBody = $(aktEl).parent('[data-screen]').find('table tbody').n
    let search = aktEl.value;
    [...aktTableBody.rows].map(e => e.style
       .display=[...e.cells]
        .map(e => e.innerText)
        .join(';').match(RegExp(search,'i'))?'':'none');  
  })
  $('[data-search]').on('blur', (evt) => evt.target.value='')
}
function show (el) {
  function insertInTable(data, aktTable){
    $(`table[data-table="${aktTable}"] tbody`).html('')
    data.rows.forEach(el=>{
      $(`table[data-table="${aktTable}"] tbody`).
       sAppend($().create('tr').setData('rowid', el.rowid))
       for(let key in el){
         if(key!=='rowid')
          $(`table[data-table="${aktTable}"] tbody tr[data-rowid="${el.rowid}"]`).
            sAppend($().create('td').text(el[key]).setData('action', 'detail'))
       }
       $(`table[data-table="${aktTable}"] tbody tr[data-rowid="${el.rowid}"]`).
          sAppend($().create('td').text('🗑').setData('action', 'deleteTableRow'))
    })
  }
  $("main [data-active]").toggleClass('hidden').removeAttr('data-active')
  $(`main>div[data-screen=${el.dataset.screen}]`).toggleClass('hidden').setAttr('data-active')
  if (el.dataset.screen=='home'){
    getInfo()
  }
  
  // check for tableOverview
  if ($(`main>div[data-screen=${el.dataset.screen}] table[data-table]`).exist()){
    let aktTable=$(`main>div[data-screen=${el.dataset.screen}] table`).getData('table')
    get({action:'overview', table: aktTable}, 
        data => insertInTable(data, aktTable), 
        data => {
          if (data.message == 'keinen Datensatz gefunden!'){
            $(`table[data-table="${aktTable}"] tbody`).html('')
          }
        }
    )
  }
  document.body.dispatchEvent(new Event ('checkForSize'))
}
function setConfirm (el) {
  confirmDialog = !confirmDialog
  $('th[data-action="setConfirm"]').each(
    el => {el.style.color = confirmDialog ? 'green' : 'red'}
  )
}
function texthelper( el ){
  let whatToDo = el.dataset.para

  let area = $(`#${$(el).parent().n.dataset.thowner}`).n
  let areaSik = area.value;
  let start = area.selectionStart
  let end = area.selectionEnd
  let selText = area.value.substring(start, end)
  let before = (area.value).substring(0, start)
  let after = (area.value).substring(end)
  let insText=''
  if (selText){
    switch (whatToDo){
      case 'bold' : 
        selText = `**${selText}**`
        end+=4
        break
      case 'italic' : 
        selText = `*${selText}*`;
        end += 2
        break;
      case 'linethrough' : 
        selText = `~~${selText}~~`;
        end+=4
        break;
      case 'code' : 
        selText = '`'+ selText +'`';
        end+=2;
        break;
      default:
      //
    }
    //area.value = before+selText+after
  } else {
    switch (whatToDo){
      case 'max':
        /*
        dialog.editor(area).then(res => {
          console.log(res)
          area.value = $('dialog:has(div [data-textedit]) textarea').n.value
        })
        */
        $(area).parent('label').toggleClass('editor-max')
        break;
      case 'newline' : 
        selText = `<br>`;
        end+=4
        break;
      case 'image':
        get({action:'getImages'}, data => {
          dialog.select('bitte Bild auswählen', data.rows)
          .then ( res => {
            if (res){
              selText =`![Beschreibung des Bildes](.${res.dialogSelect})`
              area.value = before+selText+after
              area.selectionEnd=end+selText.length
              area.focus()
            }
          })
        })
        break;
      case 'link':
       get({action:'getLinks'}, data => {
          dialog.select('bitte Seite auswählen', data.rows.map(x=>x.title))
          .then ( res => {
            if (res){
               selText =`[Beschreibung des Links](index.php?site=${res.dialogSelect})`
              area.value = before+selText+after
              area.selectionEnd=end+selText.length
              area.focus()
            }
          })
        })
        break;
      case 'brick':
        get({action:'getTextBlocks'}, data => {

          dialog.select('bitte Textbaustein auswählen', data.rows.map(x=>x.title))
          .then ( res => {
            if (res){
              selText =`<ftb>${res.dialogSelect}</ftb>`
              area.value = before+selText+after
              area.selectionEnd=end+selText.length
              area.focus()
            }
          })
        })
        break;
      case 'excelpaste':
        excelPaste(area, before, after)
        break;
      case 'excelpastejson':
        excelPasteJson(area)
        break;
      case 'preview':
        break;
      default:
        //test
    }
  }
  area.value = before+selText+after
  area.selectionEnd=end
  area.focus()
}
function upload () {
  uploader.click()
}
function version() {
  let aktVersion = $('[data-info="version"] b').text()
  let url = new URL('https://w-web.de/muscms/version.php')
  url.searchParams.append('action', 'version')
  $().getJson(
    url, 
    data => {
      console.log(data)
      if (data.version==aktVersion){
        dialog.alert('Sie sind auf dem aktuellen Stand!')
      } else {
        dialog.alert('Es ist eine neuere Version verfügbar!')
      }
    }, 
    error => {
      dialog.alert('der Server ist zur Zeit nicht erreichbar!')
    }
  )
}

function sqlEdit(){
dialog.open({
        accept: 'Ausführen',
        message: 'Bitte SQL eingeben!',
        template: `
            <form>
              <textarea name='mysqleditor' required></textarea>
            </form>`
      })
      dialog.wait().then((res) => { 
        if(res){
          console.log(res.mysqleditor) 
          get({action: 'sqlEdit', sql: res.mysqleditor},
            data=>{
              dialog.alert(`${data.message} - ${data.affected} Zeilen geändert`)
            },
            data => {
              dialog.alert(`${data.message}`)
            } 
          )          
        }
      })
}

init()


"use strict";
//https://jsfiddle.net/hj13c4gb/
function fhwMD ( md , options){
  let refLinks = []
  let footnotes = []
  let footnotesIndex = {}
  let autoID = options.autoid ?? false;
  let useMathJax = options.mathjax ?? true;
  const REGS = {
    defLi:    new RegExp(/^ *: /g),
    footnote: new RegExp(/(?<footnote>^ *\[\^(?<bez>[\d\w ]+)\]: )/),
    fCode:    new RegExp(/^ *```.*/),
    idReg:    new RegExp(/{#(?<id>.+)}/), // {#my id}
    list:     new RegExp(/^ *[-+*] |^ *\d+\. /),
    mail:     new RegExp(/<[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*>/),
    ol:       new RegExp(/^ *\d+. /),
    tag:      new RegExp(/<(?<tag>.*?)>/),
    th:       new RegExp(/^ *[\| ]*.*\|.*/), // | Head | Head |
    ul:       new RegExp(/^ *[-\*\+] /),
    refLink:  new RegExp(/(^\[(?<caption>[^\W].*?)\]:( |<|\()?)(?<url>\S*?)($| |>|\)) *(["'\(](?<title>.*?)["'\)])*/),
    links:    new RegExp(/^(?<isImageLink>\[(?=!\[[^\]\s]))*(?<isImage>!(?=\[[^\]\s]))*\[(?<caption>[^\]! ].*?)\](\[(?<ref>[^\W\]!].*?)\])*(\((?<url>[^'"\(\s]\S+?) ?(["'\(](?<title>[^"'\)].*?)["'\)])*\))*(\]|\))*(\((?<imgLinkUrl>[^'"\(]\S+)\))*/),
    isUrl:    new RegExp(/^(https?:\/\/)?((([a-z\d]([a-z\d-]*[a-z\d])*)\.)+[a-z]{2,}|((\d{1,3}\.){3}\d{1,3}))(\:\d+)?(\/[-a-z\d%_.~+]*)*(\?[;&a-z\d%_.~+=-]*)?(\#[-a-z\d_]*)?$/i)

  }
  const countRepeats = ( val, char ) => val.match( new RegExp( '^'+char+'*' ), char )[0].length ;
  const escapeHTML = str => str.replaceAll(/[&<>'"`]/g, tag => {
    var map = {
      '&': '&amp;',
      '<': '&lt;',
      '>': '&gt;',
      "'": '&#39;',
      '"': '&quot;',
      "`": '&#96;'
    };
    return map[tag] || tag;
  })
  const isEmailValid = email => /\S+@\S+\.\S+/.test(email)
  const isUrlValid = url => !!REGS.isUrl.test(url)
  const myArray = a => {
    let arr = a
    let idx = 0
    return {
      get: ( offset ) => arr[ idx+offset ] ?? false,
      isNext: () => idx < arr.length,
      next: () => arr[ idx++ ] ?? false,
      cur: () => arr[ idx ] ?? false,
      dec: () => idx -= idx > 0,
      push: ( val ) => {
        arr.push( val )
        idx = arr.length -1;
      },
      getArr: () => arr,
      change: ( val ) => arr[ idx ]= val,
      length: () => arr.length,
      pop: () => arr.pop() ?? false,
      last: () => arr[ arr.length-1 ] ?? false,
      after: ( val ) => arr.splice( idx+1, 0, val ),
      indent: () => countRepeats(arr[ idx ], ' '),
      reset: () => { idx = 0 },
      deleteAll: () => { arr = [] },
      hasData: () => arr.length > 0,
      find: ( val ) => arr.includes( val ),
      findIdx: ( val ) => arr.indexOf( val ) !== -1 ? arr.indexOf( val ) : false,
      popCount: ( count ) => {
        let ret = ''
        for ( let i=0; i < count; i++ ){
          let tmp = arr.pop() ?? false
          ret += tmp ? tmp : ''
        }
        return ret
      },
      getIdx: () => idx,
      setIdx: (val) => {idx = val}
    }
  }
  const makeTokens = ( md ) => {
    md = md.replaceAll(/\t/g, '    ') 
    let MD = myArray( md.split( /\r?\n|\r|\n/g ) )
    let tok = myArray( [] )
    tok.type   = ( offset=0 ) => tok.get( offset ).type   ?? false;
    tok.value  = ( offset=0 ) => tok.get( offset ).value  ?? false;
    tok.indent = ( offset=0 ) => tok.get( offset ).indent ?? false;
    tok.level = ( offset=0 ) => tok.get( offset ).level ?? false;
    tok.changeType = ( val ) => tok.cur().type = val;
    tok.changeLevel = ( val ) => tok.cur().level = val;
    tok.changeValue = ( val ) => tok.cur().value = val;
    tok.add = (type='', value='', indent = 0, level = 0, hId = '', codeClass='') =>
      tok.push({type,value,indent,level,hId,codeClass})
    let func = []
    const initFunc = () => {
      func['h'] = ( type, value, indent ) => {
        let level = countRepeats(value.trim(), '#') 
        if( level > 6 ) level = 6
        
        let hId = value.match(REGS.idReg)?.groups.id.
            replaceAll(' ','-') ?? false

        if (!hId && autoID==true){
           hId = value.trim().slice(level).trim().toLowerCase() //.replaceAll(' ','-')
           hId = hId.replace(/[^a-zA-Z-0-9\s]/g, '');
           hId = hId.replaceAll(' ','-')

        }

        value=value.slice(indent).trim().replace(REGS.idReg,'')        
        
        tok.add (type, 
                 value, 
                 indent, 
                 level, 
                 hId)
      }
      func['h1'] = ( type, value, indent ) => {
        if(tok.type()=='p'){
          value = '# ' + tok.value()
          tok.pop()
          tok.add('h', value, indent, 1 )
          return
        }
        type = 'p'
        tok.add( 'p', value, indent )
      }
      func['h2'] = ( type, value, indent ) => {
        if(tok.type()=='p'){
          value = '# ' + tok.value()
          tok.pop()
          tok.add( 'h', value , indent, 2 )
          return
        }
        tok.add( 'hr', value, indent )
      }
      func['hr'] = ( type, value, indent ) => {
        tok.push( {type, value, indent} )
      }
      func['table'] = ( type, value, indent ) => {
        let thead = REGS.th.exec(tok.value())
        let tbody = REGS.th.exec(MD.get(1))
        if (thead && tbody){
          tok.changeType('table')
          tok.push( {type, value, indent} )
          MD.next()
          while(MD.isNext()){
            if(!REGS.th.exec(MD.cur())){
              MD.dec()
              break;
            }
            tok.add( type, MD.cur(), indent )
            MD.next()
          }
          return
        }
        tok.add( 'p', value, indent )
      }
      func['blockquote'] = ( type, value, indent ) => {
        let level = countRepeats(value, '>') 
        value = value.slice(indent+level+1)
        tok.push( {type, value, indent, level} )
      }
      func['code'] = ( type, value, indent ) => {
        tok.add( type, value.slice(4), indent )
      }
      func['fcode'] = ( type, value, indent ) => {
        //let reg = new RegExp(/^ *```.*/)
        let aktIndent = MD.indent()
        type = 'code'
        let codeClass = value.trimStart().slice(3).trim()
        MD.next()
        while(MD.isNext()){
          if(REGS.fCode.exec(MD.cur())){
              break;
          }
          if(MD.indent()<aktIndent){
            MD.dec()
            break;
          }
          value = MD.cur().slice(aktIndent)
          tok.add( type, 
                   MD.cur().slice(aktIndent), 
                   MD.indent()-aktIndent, 
                   null, 
                   null,
                   codeClass )
          MD.next()
        }
      }
      func['blank'] = ( type, value, indent ) => {
        if (tok.type==type) return
        tok.push( {type, value, indent} )
      }
      func['p'] = ( type, value, indent ) => {
        tok.push( {type, value, indent} )
      }
      func['list'] = (type, value, indent) => {
        let aktIndent = 0
        let tempIndent = 0
        while(MD.isNext()){
          if(REGS.list.exec(MD.cur())){
             aktIndent = MD.indent()+2
          }
          if( MD.indent()==0 && !REGS.list.exec(MD.cur())){
            if(MD.cur()==''){
              MD.dec()
              break
            }
          }
          if (MD.indent() > aktIndent){
            tempIndent = aktIndent
          } else {
            tempIndent = MD.indent()
          }
          //value = MD.cur().slice(tempIndent)
          //indent = MD.indent()
          //tok.push ({ type, value, indent })
          tok.add ( type, 
                 MD.cur().slice(tempIndent), 
                 MD.indent())
          MD.next()
        }
        if(tok.type()=='list' && tok.value()==''){
          tok.changeType('blank')
        }
      }
      func['html'] = ( type, value, indent ) => {
        let tag = REGS.tag.exec(value)?.groups.tag 
        
        let encTag = encodeURI(tag)        
        if(isUrlValid(encTag)) {type='p'}      
        if(isEmailValid(tag)) {type = 'p'}    
        
        tok.push( {type, value, indent} )
      }
      func['deflist'] = (type, value, indent) => {
        let isDefList = tok.type()=='p';
        let aktIndent = MD.indent()
        let level =''
        if (isDefList){
          tok.changeType('deflist')
          tok.changeLevel('dt')
          while(MD.isNext()){
             while(MD.indent() > aktIndent){
              //value=MD.cur()
              //level = 'ddchild'
              //tok.push({type, value, level, indent})
              tok.add(type, MD.cur(), indent, 'ddchild')
              MD.next()
            }
            if (!MD.cur().match(/^ *: /g)){
              MD.dec()
              break;
            }
            value = MD.cur().slice(indent)
            level = "dd"
            tok.push({type, value, level, indent})
            MD.next()
          }    

        } else {
            while(MD.isNext()){
              if (!MD.cur().match(REGS.defLi)){
               MD.dec()
               break;
             }
             //type='p'
             //value = MD.cur().slice(indent)
             //tok.push({type,value,indent})
             tok.add('p',MD.cur().slice(indent),indent)
             MD.next()
            } 
            return
        }    
      }
      func['reflink'] = ( type, value, indent ) => {
        let match = REGS.refLink.exec(value)
        if(match){
          let caption = match.groups.caption.replaceAll(/[^a-zA-Z-0-9\s]/g, '');
          caption = caption.trim().replaceAll(' ', '-').toLowerCase()
          let title = match.groups.title ?? ''
          let url = match.groups.url ?? null
          if(!url){
            return
          }
          refLinks[caption]={url, title}
          return
        }
        return       
      }
      func['footnote'] = (type, value, indent) => {
        let footName = value.match(REGS.footnote).groups.bez
        footName=footName.replaceAll(' ', '-').toLowerCase()
        footnotesIndex[footName]=Object.keys(footnotesIndex).length+1
        value = value.replace(REGS.footnote,'')
        let level = 'parent'
        tok.push({type, value, indent , level, footName})
        let aktIndent = false;
        MD.next()
        while(MD.isNext()){
          if(!aktIndent){
            aktIndent=MD.indent()
          }
          if(MD.cur()==""){
            break;
          }
          if(MD.cur().match(REGS.footnote)){
            break;
          }
          if(!(MD.indent()>= aktIndent) ){
            break;
          }
          if(MD.indent()==0){
            break;
          }
          value = MD.cur().slice(aktIndent)
          level = 'child'
          indent = MD.indent() - aktIndent;
          tok.push({type, value, indent , level, footName})
          MD.next()
        }
        let fIndex = footnotesIndex[footName] ?? 'error'
        tok.changeValue(tok.value() + `[&#9166;](#footnoteret-${footName} "zurück")`)
        MD.dec()
      }
      func['mathjax'] = (type, value, indent) => { 
        let reg = /^ *\$\$$/
        type = 'mathjax'
        let aktIndent = MD.indent()
        MD.next()
        while(MD.isNext()){
          if (MD.cur().match(reg)){
            break;
          }
          if(MD.indent()<aktIndent){
            MD.dec()
            break;
          }
          value = MD.cur().slice(aktIndent)
          tok.add( type, 
            MD.cur().slice(aktIndent), 
            MD.indent()-aktIndent, 
            null, 
            null,
            null )
          MD.next()
        }
      }

    }
    initFunc()
    //-fhw const regs = []
    const regs = myArray([])
    const regsInit= () => {
      regs.push('(?<code>^ {4,})')
      regs.push('(?<h>^ *#+)')
      regs.push('(?<h1>^ *===+ *$)')
      regs.push('(?<h2>^ *---+ *$)')
      regs.push('(?<hr>^ *[_\*]{3,} *$)')
      regs.push('(?<table>^ *[\\| ]*[ -:]+\\|.*)')
      regs.push('(?<fcode>^ *```.* *)')
      //regs.push('(?<code>^ {4,})')
      regs.push('(?<list>^ *[-+*] |^ *\\d+\\. )')
      regs.push('(?<html>^ *<.*?>)')
      regs.push('(?<blockquote>^ *>+ *)')
      regs.push('(?<blank>^ *$)')
      regs.push('(?<deflist>^ *: )')
      regs.push('(?<footnote>^ *\\[\\^(?<bez>[\\d\\w ]+)\\]: )')
      regs.push('(?<reflink>^\\[.*\\]:)')
      if(useMathJax==true){
        regs.push('(?<mathjax>^ *\\$\\$$)') // MathJax
      }
      regs.push('(?<p>^.*$)') 
      
    }
    regsInit()
    const checkType = new RegExp( regs.getArr().join('|'))  
    const getType = value => {
      let tmp = checkType.exec( value );
      if(tmp){
        
        return Object.keys( tmp.groups ).
          find( k=>tmp.groups[k] !== undefined )
      }
      return('p')
    }
    while( MD.isNext() ){
      let value = MD.cur()
      let type = getType( value )
      let indent = MD.indent()
      func[type](type, value, indent)
      MD.next()
    }
    tok.reset()
    //tk.innerText+=JSON.stringify(tok.getArr(),0,2)

    return tok
  }
  const renderHtml = ( tok ) => {
    const rerender = md => renderHtml(makeTokens( md ))
    let htm = myArray ( [] )
    let func = []
    const initFunc =() => {
      func['h'] = (t) => {
        let refId=''
        if(t.hId){
          refId = ` id="${t.hId.replaceAll(' ','-')}"`
        } 
        htm.push(`<h${t.level}${refId}>${parseLine(t.value.slice(t.level).trim())}</h${t.level}>`)
      }
      func['blank'] = () => {}
      func['p'] = (t) => {
        let tmp=''
        if(tok.type(-1)=='p'){
          htm.pop()
          let tmp = tok.value(-1).replace(/  $/,'<br>')+' '
          tok.changeValue(tmp+t.value)
        }
        htm.push(`<p>${parseLine(t.value)}</p>`)
      }
      func['hr'] = () => htm.push('<hr>')                   
      func['code'] = (t) => {
        let tmp = ''
        if(t.codeClass) {
          tmp = ` class="language-${t.codeClass} ${t.codeClass}"`
        }
        htm.push(`<pre><code${tmp}>${escapeHTML(t.value)}`)      

        tok.next()
        while(tok.isNext()){
          if (tok.type()!=='code'){
            tok.dec()
            break;
          }
          htm.push(escapeHTML(tok.value()))
          tok.next()
        }
        htm.push(`</code></pre>`)
      }
      func['mathjax'] = (t) => {
        htm.push(`<div class="mdpmath">$$`)
        htm.push(t.value)
        tok.next()
        while(tok.isNext()){
          if (tok.type()!=='mathjax'){
            tok.dec()
            break;
          }
          htm.push(tok.value())
          tok.next()
        }
        htm.push(`$$</div>`)
      }
      func['list'] = () => {
        let tmpMd = []
        let diff = 0
        let diffStack = myArray( [] )
        let stack = myArray( [] )
        let aktListType = '';

        if (REGS.ul.exec(tok.value())){
          aktListType='ul'
        }
        if (REGS.ol.exec(tok.value())){
          aktListType='ol' 
        } 
        htm.push(`<${aktListType}>`)
        stack.push(`</${aktListType}>`)
        diffStack.push(tok.indent()) // Diff

        /* wenn nur ein Eintrag **/
        if (tok.get(1)){
          tmpMd.push(tok.value().replace(REGS.list, ''));
          tok.next()
        } else{
          htm.push('<li>'+parseLine(tok.value().replace(REGS.list, ''))+stack.pop())
          return
        }

        while(tok.isNext()){

          if( tok.type() !== 'list' ){
            break;
          }

          let isList = REGS.list.exec(tok.value())
          if(isList){
            htm.push('<li>')   
            if(tmpMd.length==1){
              htm.push(parseLine(tmpMd[0]))
            } else {
              if (tmpMd.length > 1){
                if (tmpMd[1]){
                  if(tmpMd[1].match(REGS.list)){
                    htm.push(parseLine(tmpMd[0]))
                    tmpMd.shift() 
                  }
                }
              }
              htm.push(rerender(tmpMd.join('\n'))) 
            }
            tmpMd=[] 
            if (tok.indent()>diffStack.last()){
              if (REGS.ul.exec(tok.value())){
                aktListType='ul'
              }
              if (REGS.ol.exec(tok.value())){
                aktListType='ol' 
              } 
              htm.push(`<${aktListType}>`)
              stack.push(`</${aktListType}>`)
              diffStack.push(tok.indent()) // diff
            }

            if( tok.indent() < diffStack.last() ){

              if ( diffStack.find( tok.indent())){
                diff = diffStack.length() - diffStack.findIdx(tok.indent()) - 1
              } else {
                let tmpIdx = 0
                while (diffStack.get(tmpIdx) > tok.indent()){
                  tmpIdx--
                }
                diff = tmpIdx*-1-1
              }
              for ( let i=0; i < diff; i++){
                diffStack.pop()
                htm.push(stack.pop())
              }  
            }
          }
          tmpMd.push(tok.value().replace(REGS.list, ''))
          tok.next()

        }
        htm.push('<li>')
        if(tmpMd.length==1){
          htm.push(parseLine(tmpMd[0]))  
        } else {
          if (tmpMd.length > 1){
            if (tmpMd[1]){
              if(tmpMd[1].match(REGS.list)){
                htm.push(parseLine(tmpMd[0]))
                tmpMd.shift() 
              }
            }
          }
          htm.push(rerender(tmpMd.join('\n'))) 
        }
        while(stack.last()){
          htm.push(stack.pop())
        }
        tok.dec()
      }
      func['table'] = () => {
        let getAligns = () => {
          let aligns = tok.value(1).replace(/^ *\||\| *$/g,'').split('|')
          aligns.forEach((el,i)=>{
            let aktEl = el.trim()
            aligns[i]=''
            if (aktEl.match(/^:.*:$/)){
              aligns[i]=' style="text-align: center;"'
            }
            if (aktEl.match(/^:-*$/)){
              aligns[i]=' style="text-align: left;"'
            }
            if (aktEl.match(/^-*:$/)){
              aligns[i]=' style="text-align: right;"' 
            }
          })
          return aligns;
        }
        let aligns = getAligns()
        let tHead = tok.value().replace(/^ *\||\| *$/g,'').split('|')
        tok.next()
        tok.next()
        let tbody = []
        
        while(tok.isNext()){
          if(tok.type()!=="table"){
            tok.dec()
            break;
          }
          tbody.push(tok.value().replace(/^ *\||\| *$/g,'').split('|'))
          tok.next()
        }
        //get max ColCount
        let cols = tHead.length
        //fhw

        tbody.forEach(el=>{
          if (el.length > cols){
            cols=el.length
          }
        })
        
        // write Table
        htm.push('<table>')
        htm.push('<thead><tr>')
        for (let i=0; i<cols;i++){
          let aktVal= tHead[i] ?? ""
          let aktAlign = aligns[i]??""
          htm.push(`<th${aktAlign}>`)
          htm.push(parseLine(aktVal.trim()))
          htm.push("</th>")
        }
        htm.push('</tr></thead>')
        htm.push('<tbody>')
        tbody.forEach(el => {
          htm.push('<tr>')
          for (let i=0; i<cols;i++){
            let aktVal= el[i] ?? ""
            let aktAlign = aligns[i]??""
            htm.push(`<td${aktAlign}>`)
            htm.push(parseLine(aktVal.trim()))
            htm.push("</td>")
          }
          htm.push('</tr>')
        })
        htm.push('</tbody>')
        htm.push('</table>')
      }
      func['blockquote'] = () => {
        let tmpMd = "";
        let bqStack = myArray( [] )
        htm.push('<blockquote>')
        bqStack.push('</blockquote>')
        let aktLevel = tok.level()
        while(tok.isNext()){
          if (tok.type()!=="blockquote"){
            tok.dec()
            break;
          }
          if( aktLevel !== tok.level() ) {
            htm.push(rerender(tmpMd))
            let diff = tok.level() - aktLevel
            if ( diff > 0 ){
              for (let i=0;i<diff;i++){
                 htm.push('<blockquote>')
                 bqStack.push('</blockquote>')
              }
            } else{
              htm.push(bqStack.popCount(diff*=-1))
            }
            aktLevel=tok.level()
            tmpMd=''
          }
          tmpMd += tok.value() + `\n`
          tok.next()
        }
        htm.push(rerender(tmpMd))
        while (bqStack.last()){
          htm.push(`${bqStack.pop()}`)
        } 
      }
      func['html'] = () => {
        htm.push(tok.value())
      }
      func['deflist'] = () => {
        htm.push('<dl>')
        while(tok.isNext()){
          if (tok.type()=='blank' && tok.type(1)!=='deflist' ){
            tok.dec()
            break;
          }

          if (tok.type()!=='deflist' && tok.type()!=='blank' ) {
            tok.dec()
            break;
          }   

          if (tok.type()!=='blank'){
                if (tok.level()=='dt'){
                  htm.push(
                  "<dt>" + 
                  parseLine(tok.value().replace(/^ *: /,''))+
                  "</dt>"
                  )
                }
                if (tok.level()=='dd'){
                  if (tok.level(1)=="ddchild"){
                    let tempMd=[]
                    tempMd.push(tok.value().replace(/^ *: /,''))
                    tok.next()
                    while(tok.isNext()){
                        if(tok.level()!=="ddchild"){
                          htm.push('<dd>')
                          htm.push(rerender(tempMd.join('\n')))
                          htm.push('</dd>')
                          tok.dec()
                          break;
                        }
                        tempMd.push(tok.value())
                        tok.next()
                    }
                  } else{
                    htm.push(
                    "<dd>" + 
                    parseLine(tok.value().replace(/^ *: /,''))+
                    "</dd>"
                    )
                  }
                }
          }

          tok.next()
        }
        htm.push('</dl>')
      }
      func['footnote'] = () => {
        let tmpMd = []
        let footName = tok.cur().footName
        tmpMd.push(tok.value())
        tok.next()
        while(tok.isNext()){
          if(tok.cur().level !== 'child'){
            break;
          }
          tmpMd.push(tok.value())
          tok.next()
        }       
        footName=footName.replaceAll(' ', '-')
        footnotes.push(`<li id="footnote-${footName}">` + 
          rerender(tmpMd.join('\n')) 
        )
        tok.dec() 
      }
    }
    initFunc()
    while( tok.isNext() ){ 
      func[tok.type()](tok.cur())
      tok.next()
    }
    return htm.getArr().join(`\n`) 
  }
  const parseLine = (line) => {
    let chars = myArray(line.split(''))
    let plainMD = line
    let htm = myArray([])
    let stack = myArray([])
    let tmpStack = myArray([])
    
    function checkForSpaceAround(count){
      if(chars.get(-1)==" " && chars.get(count)==" "){
        htm.push(chars.cur())
        if(count==2){
          htm.push(chars.get(1))
          chars.next()
        }
        return true
      }
      return false
    }
    function handleStack(el){
      while(tmpStack.last()!==el){
        htm.push(`</${stack.last()}>`)
        tmpStack.push(stack.pop()) 
      }
      tmpStack.pop()
      while (tmpStack.last()){
        htm.push(`<${tmpStack.last()}>`)
        stack.push(tmpStack.pop())    
      }  
    }
    function handleMarkup(el){
      if (htm.last()==`<${el}>`){
        htm.pop();
        stack.pop();
        return
      }
      if (stack.find(el)){
        handleStack(el)
      } else {
        htm.push(`<${el}>`) 
        stack.push(el) 
      }
    }
    function handleCode(){
      let restOfLine = plainMD.substr(chars.getIdx())
      let creg = /^(?<!`)`(?!`)(?<code>.*?)(?<!`)`(?!`)/
      htm.push('<code>')
      stack.push('code')
      let m=creg.exec(restOfLine)
      if (m) {
          htm.push(escapeHTML(m.groups.code))
          chars.setIdx(chars.getIdx()+m[0].length-1)
          htm.push(`</${stack.pop()}>`)
          return;
      } 
    }
    function handleEscapedCode(){
      htm.push('<code>')
      stack.push('code')
      chars.dec()
      let restOfLine = plainMD.substr(chars.getIdx())
      let creg = /^(?<!`)``(?!`)(?<code>.*?)(?<!`)``(?!`)/;
      let m=creg.exec(restOfLine)
      if (m) {
          htm.push(escapeHTML(m.groups.code))
          chars.setIdx(chars.getIdx()+m[0].length-1)
          htm.push(`</${stack.pop()}>`)
          return;
      }  
    }
    function handleLink(){
      let restOfLine = plainMD.substr(chars.getIdx())
      let match = REGS.links.exec(restOfLine)
      if(match){
        let makeUrl = ''
        let isImageLink = match.groups.isImageLink ?? null;
        let isImage = match.groups.isImage ?? null;
        let caption = match.groups.caption ?? "";
        let ref = match.groups.ref ?? null;
        let url = match.groups.url ?? null;
        let title = match.groups.title ?? null;
        let imgLinkUrl = match.groups.imgLinkUrl ?? null;
        let linkLen = match[0].length

        let linkTitle = ''
        if(title){
          linkTitle = ` title="${title}"`
        }
        let linkUrl = ''
        if(url){
          linkUrl = encodeURI(url.trim())
        }
        let linkImgLinkUrl = ''
        if (imgLinkUrl){
          linkImgLinkUrl = encodeURI(imgLinkUrl.trim())
        }
        if (caption[0]==`^` && url==null){
          let newCaption = caption.slice(1).replaceAll(' ', '-').toLowerCase()
          let fIndex = footnotesIndex[newCaption] ?? 'error'
          return[
            `<sup id=footnoteret-${newCaption}><a href="#footnote-${newCaption}">${fIndex}</a></sup>`,
            linkLen
          ]
        }
        if(isImageLink){
          if (caption!==''){
            caption = ` alt="${caption}"`
          }
          return[`<a href="${linkImgLinkUrl}"><img src="${linkUrl}" ${caption}${linkTitle}></a>`, linkLen]
        }
        if(isImage){
          
          if (caption && !url &&!ref){
           
            let tmpRef = caption.replaceAll(/[^a-zA-Z-0-9\s]/g, '')
            tmpRef = tmpRef.trim().replaceAll(' ', '-').toLowerCase()
           
            let tmpLink = refLinks[tmpRef]?.url ?? null
            if (tmpLink){
              let tmpTitle = refLinks[tmpRef].title ?? null
              let linkTitle=""
              if (tmpTitle){
                linkTitle = ` title="${tmpTitle}"`
              }
              return [`<img src="${tmpLink}" alt="${caption}"${linkTitle}>`, linkLen]
            }
          }
          if(ref){
            
            let tmpRef = ref.replaceAll(/[^a-zA-Z-0-9\s]/g, '')
            tmpRef = tmpRef.trim().replaceAll(' ', '-').toLowerCase()
            let tmpLink = refLinks[tmpRef]?.url ?? null
            if (tmpLink){
              let tmpTitle = refLinks[tmpRef].title ?? null
              let linkTitle=""
              if (tmpTitle){
                linkTitle = ` title="${tmpTitle}"`
              }
              return [`<img src="${tmpLink}" alt="${caption}"${linkTitle}>`, linkLen]
            }
            htm.push(chars.cur())
            return[false,'']
          }

          if (caption!=''){
            caption = ` alt="${caption}"`
          }
          if(!url){
            htm.push(chars.cur())
            return[false,'']
          }
          
          return [`<img src="${linkUrl}"${caption}${linkTitle}>`, linkLen]
        }
        if(ref){
          
          let tmpRef = ref.replaceAll(/[^a-zA-Z-0-9\s]/g, '')
          tmpRef = tmpRef.trim().replaceAll(' ', '-').toLowerCase()
          let tmpLink = refLinks[tmpRef]?.url ?? null
          if (tmpLink){
            let tmpTitle = refLinks[tmpRef].title ?? null
            let linkTitle=""
            if (tmpTitle){
              linkTitle = ` title="${tmpTitle}"`
            }
            return [`<a href="${tmpLink}"${linkTitle}>${caption}</a>`, linkLen]
          }
          htm.push(chars.cur())
          return[false,'']
        }

        if(caption && !url){ // only ref in caption
          
          let tmpRef = caption.replaceAll(/[^a-zA-Z-0-9\s]/g, '')
          tmpRef = tmpRef.trim().replaceAll(' ', '-').toLowerCase()
          let tmpLink = refLinks[tmpRef]?.url ?? null
          if (tmpLink){
            let tmpTitle = refLinks[tmpRef].title ?? null
            let linkTitle=""
            if (tmpTitle){
              linkTitle = ` title="${tmpTitle}"`
            }
            return [`<a href="${tmpLink}"${linkTitle}>${caption}</a>`, linkLen]
          }
          htm.push(chars.cur())
          return[false,'']
        }
        return [`<a href="${linkUrl}"${linkTitle}>${caption}</a>`, linkLen]
      }
      htm.push(chars.cur())
      return[false,'']
    }

    function findNext(counter, val){
      let textBetween =""
      while(chars.get(counter)){
        if (chars.get(counter)==val){
          break;
        }
        textBetween+=chars.get(counter)
        counter++
      }
      return [textBetween, counter]
    }
    function handleEmailOrUrl(){
    
      let content=""
      let counter=1;
      [content, counter] = findNext(counter, '>')
      if (!chars.get(counter) || content==""){
        htm.push(escapeHTML(chars.cur()))
        return [false,'']
      }
      
      if(isEmailValid(encodeURI(content))){
        htm.push(`<a href="mailto:${content}">${content}</a>`)
        chars.setIdx(chars.getIdx()+counter);
        return
      }
      if(isUrlValid(encodeURI(content))){
        htm.push(`<a href="${content}">${content}</a>`)
        chars.setIdx(chars.getIdx()+counter);
        return
      }
      htm.push(chars.cur())
    }    
    function handleDirectLink(){
      let restOfLine = plainMD.substr(chars.getIdx())
      let counter=0;
      let after = ''
      while(chars.get(counter)){
        if(' <'.includes(chars.get(counter))){
          break;
        }
        after+=chars.get(counter)
        counter++
      }
      counter = -1
      let before=''
      while(chars.get(counter)){
        if(' >'.includes(chars.get(counter))){
          break;
        }
        before=chars.get(counter)+before
        counter--
      }
                 
      let directLink = encodeURI(before + after)
      if (isUrlValid(directLink)){
        chars.setIdx(chars.getIdx()+after.length-1)
        htm.popCount(before.length)
        htm.push(`<a href="${directLink}">${before+after}</a>`)
        return
      }
      if (isEmailValid(directLink)){
        chars.setIdx(chars.getIdx()+after.length-1)
        htm.popCount(before.length)
        htm.push(`<a href="mailto:${directLink}">${before+after}</a>`)
        return
      }
      
      htm.push(chars.cur())
      return
    }
    function handleMathJax(){
      let restOfLine = plainMD.substr(chars.getIdx())
      let mathJaxReg = /^\$\$(?<mathjax>.*?)\$\$/
      let m = mathJaxReg.exec(restOfLine)
      if(m){
        htm.push(`<span class="mathjax">$$${m.groups.mathjax}$$</span>`)
        chars.setIdx(chars.getIdx()+m[0].length-1)
        return
      }
      htm.push(chars.cur())
      chars.next()
      htm.push(chars.cur())

    }
    function parse(){
      while( chars.isNext() ){
        let actChar = chars.cur()

        let specialChars = '*_^=\\`[!<~:@'

        if(useMathJax==true){
          specialChars += '$'
        }

        if (specialChars.includes(actChar)){
          
          switch (actChar){
            case "*" : case '_':
    
              if(checkForSpaceAround(1)){
                break;
              }               
                      
              if( chars.get(1) == "*" || chars.get(1) == "_" ){
                if(checkForSpaceAround(2)){
                  break;
                }
                
                chars.next()
                handleMarkup('strong')
              } else{
                handleMarkup('em')
              }
              break;

            case '^':
              if(checkForSpaceAround(1)){
                break;
              }
              handleMarkup('sup')
              break;

            case "~":
              if(checkForSpaceAround(1)){
                break;
              }
              if( chars.get(1) == "~"){
                if(checkForSpaceAround(2)){
                  break;
                }
                chars.next()
                handleMarkup('del')
              } else{
                handleMarkup('sub')
              }
              break; 

            case "=":
              if(checkForSpaceAround(1)){
                break;
              }
              if( chars.get(1) == "="){
                if(checkForSpaceAround(2)){
                  break;
                }
                chars.next()
                handleMarkup('mark')
              } else{
                htm.push(chars.cur())
              }
              break;  

            case"\\":
              if(chars.isNext()){
                chars.next()
                htm.push(escapeHTML(chars.cur()))
              } else{
                htm.push(chars.cur())
              }

            break;  

            case "`":
              if( chars.get(1) == "`"){
                chars.next()
                handleEscapedCode()
              } else {
                handleCode()
              }
              break;              

            case "[": case"!":
              if(checkForSpaceAround(1)){
                break;
              }
              let [isLink, counter] = handleLink()
              if (isLink){
                htm.push(isLink)
                chars.setIdx(chars.getIdx()+counter-1);
              }
              break;
            case "<":
              if(checkForSpaceAround(1)){
                break;
              }  
              handleEmailOrUrl()
              break;
            case ":": case "@":
              handleDirectLink()
              break;
            
            case "$":
              if(checkForSpaceAround(1)){
                break;
              } 
              if( chars.get(1) == "$" ){
                handleMathJax()
              }
              break;
            
            default:
              break;
          }
          
        } else {
          htm.push(chars.cur())
        }
        chars.next()
      }
    }
    parse()
    while(stack.last()){
      htm.push(`</${stack.pop()}>`)
    }
    return htm.getArr().join('')
  }
  
  let tok =  makeTokens(md)
  let ret =  renderHtml( tok )
  //let ret =  ''
 
  if(footnotes.length>0){
    return ret + '<hr>' + '<ol>' + footnotes.join('\n') + '</ol>'
  }
  return ret
}


</script>
</body>
</html>
<?PHP
/*end htm*/
}

